;CodeVisionAVR C Compiler V1.24.7d Standard
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega32
;Program type           : Application
;Clock frequency        : 3,686000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 841 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R24,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "rs.vec"
	.INCLUDE "rs.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x3A9)
	LDI  R29,HIGH(0x3A9)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x3A9
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.7d Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 e-mail:office@hpinfotech.com
;       8 
;       9 Project : RScode
;      10 Version : 3.1
;      11 Date    : 3.4.2008
;      12 Author  : Tomas                           
;      13 Company : Tomas                           
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega32
;      18 Program type        : Application
;      19 Clock frequency     : 3,686000 MHz
;      20 Memory model        : Small
;      21 External SRAM size  : 0
;      22 Data Stack size     : 512
;      23 *****************************************************/
;      24 
;      25 #include <mega32.h>
;      26 
;      27 // Standard Input/Output functions
;      28 #include <stdio.h>
;      29 #include <delay.h>
;      30 
;      31 // Declare your global variables here
;      32 
;      33 // mm  4
;      34 // nn  15
;      35 // tt  1 , 2 , 3 , 4 
;      36 // kk  13, 11, 9 , 7
;      37 
;      38 int pp[5] = { 1, 0, 0, 1, 1} ;             //polynom
_pp:
	.BYTE 0xA
;      39 int alpha_to [15+1], index_of [15+1], gg [15-7+1] ;
_alpha_to:
	.BYTE 0x20
_index_of:
	.BYTE 0x20
_gg:
	.BYTE 0x12
;      40 int recd[16];
_recd:
	.BYTE 0x20
;      41 int data0[14], bb0[8] ;
_data0:
	.BYTE 0x1C
_bb0:
	.BYTE 0x10
;      42 int data0_prokladane[210];
_data0_prokladane:
	.BYTE 0x1A4
;      43 
;      44 char chyba = 1;
;      45 
;      46 int typ_zpravy=0;
;      47 
;      48 int nn=15;
;      49 int mm=4;
;      50 int kk;
;      51 int tt;
;      52 #pragma warn-
;      53 
;      54 void generate_gf() {

	.CSEG
_generate_gf:
;      55   int i, mask ;
;      56   mask = 1 ;
	CALL __SAVELOCR4
;	i -> R16,R17
;	mask -> R18,R19
	__GETWRN 18,19,1
;      57   alpha_to[4] = 0 ;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _alpha_to,8
;      58   for (i=0; i<4; i++)
	__GETWRN 16,17,0
_0x8:
	__CPWRN 16,17,4
	BRGE _0x9
;      59    { alpha_to[i] = mask ;
	CALL SUBOPT_0x0
	ADD  R26,R30
	ADC  R27,R31
	ST   X+,R18
	ST   X,R19
;      60      index_of[alpha_to[i]] = i ;
	CALL SUBOPT_0x0
	CALL SUBOPT_0x1
;      61      if (pp[i]!=0)
	MOVW R30,R16
	LDI  R26,LOW(_pp)
	LDI  R27,HIGH(_pp)
	CALL SUBOPT_0x2
	SBIW R30,0
	BREQ _0xA
;      62        alpha_to[4] ^= mask ;
	__POINTW2MN _alpha_to,8
	CALL __GETW1P
	EOR  R30,R18
	EOR  R31,R19
	ST   X+,R30
	ST   X,R31
;      63      mask <<= 1 ;
_0xA:
	LSL  R18
	ROL  R19
;      64    }
	__ADDWRN 16,17,1
	RJMP _0x8
_0x9:
;      65   index_of[alpha_to[4]] = 4 ;
	__GETW1MN _alpha_to,8
	CALL SUBOPT_0x3
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   X+,R30
	ST   X,R31
;      66   mask >>= 1 ;
	ASR  R19
	ROR  R18
;      67   for (i=4+1; i<15; i++)
	__GETWRN 16,17,5
_0xC:
	__CPWRN 16,17,15
	BRGE _0xD
;      68    { if (alpha_to[i-1] >= mask)
	CALL SUBOPT_0x4
	CP   R30,R18
	CPC  R31,R19
	BRLT _0xE
;      69         alpha_to[i] = alpha_to[4] ^ ((alpha_to[i-1]^mask)<<1) ;
	CALL SUBOPT_0x0
	CALL SUBOPT_0x5
	EOR  R30,R18
	EOR  R31,R19
	LSL  R30
	ROL  R31
	__GETW2MN _alpha_to,8
	EOR  R30,R26
	EOR  R31,R27
	RJMP _0x39F
;      70      else alpha_to[i] = alpha_to[i-1]<<1 ;
_0xE:
	CALL SUBOPT_0x0
	CALL SUBOPT_0x5
	LSL  R30
	ROL  R31
_0x39F:
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;      71      index_of[alpha_to[i]] = i ;
	CALL SUBOPT_0x0
	CALL SUBOPT_0x1
;      72    }
	__ADDWRN 16,17,1
	RJMP _0xC
_0xD:
;      73   index_of[0] = -1 ;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	STS  _index_of,R30
	STS  _index_of+1,R31
;      74  } 
	RJMP _0x39E
;      75 
;      76 
;      77 void gen_poly0() {
_gen_poly0:
;      78    int i,j ;
;      79    gg[0] = 2 ;    
	CALL __SAVELOCR4
;	i -> R16,R17
;	j -> R18,R19
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	STS  _gg,R30
	STS  _gg+1,R31
;      80    gg[1] = 1 ;    
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1MN _gg,2
;      81    for (i=2; i<=15-13; i++)
	__GETWRN 16,17,2
_0x11:
	__CPWRN 16,17,3
	BRLT PC+3
	JMP _0x12
;      82     { gg[i] = 1 ;
	CALL SUBOPT_0x6
	CALL SUBOPT_0x7
;      83       for (j=i-1; j>0; j--)
	MOVW R30,R16
	SBIW R30,1
	MOVW R18,R30
_0x14:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x15
;      84         if (gg[j] != 0)  gg[j] = gg[j-1]^ alpha_to[(index_of[gg[j]]+i)%15] ;
	CALL SUBOPT_0x8
	SBIW R30,0
	BREQ _0x16
	CALL SUBOPT_0x9
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	CALL SUBOPT_0xC
	EOR  R30,R22
	EOR  R31,R23
	POP  R26
	POP  R27
	RJMP _0x3A0
;      85         else gg[j] = gg[j-1] ;
_0x16:
	CALL SUBOPT_0x9
	MOVW R0,R30
	CALL SUBOPT_0xA
	CALL SUBOPT_0x2
	MOVW R26,R0
_0x3A0:
	ST   X+,R30
	ST   X,R31
;      86       gg[0] = alpha_to[(index_of[gg[0]]+i)%15] ;     /* gg[0] can never be zero */
	__SUBWRN 18,19,1
	RJMP _0x14
_0x15:
	LDS  R30,_gg
	LDS  R31,_gg+1
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	CALL SUBOPT_0xC
	STS  _gg,R30
	STS  _gg+1,R31
;      87     }
	__ADDWRN 16,17,1
	RJMP _0x11
_0x12:
;      88    /* convert gg[] to index form for quicker encoding */
;      89    for (i=0; i<=15-13; i++)  gg[i] = index_of[gg[i]] ;
	__GETWRN 16,17,0
_0x19:
	__CPWRN 16,17,3
	BRGE _0x1A
	CALL SUBOPT_0x6
	CALL SUBOPT_0xD
	LDI  R26,LOW(_gg)
	LDI  R27,HIGH(_gg)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;      90  }
	__ADDWRN 16,17,1
	RJMP _0x19
_0x1A:
_0x39E:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;      91  
;      92 void encode_rs0() {
_encode_rs0:
;      93    int i,j ;
;      94    int feedback ;
;      95    for (i=0; i<15-13; i++)   bb0[i] = 0 ;
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	feedback -> R20,R21
	__GETWRN 16,17,0
_0x1C:
	__CPWRN 16,17,2
	BRGE _0x1D
	MOVW R30,R16
	CALL SUBOPT_0xE
;      96    for (i=13-1; i>=0; i--)
	__ADDWRN 16,17,1
	RJMP _0x1C
_0x1D:
	__GETWRN 16,17,12
_0x1F:
	SUBI R16,0
	SBCI R17,0
	BRGE PC+3
	JMP _0x20
;      97     {  feedback = index_of[data0[i]^bb0[15-13-1]] ;
	MOVW R30,R16
	LDI  R26,LOW(_data0)
	LDI  R27,HIGH(_data0)
	CALL SUBOPT_0x2
	MOVW R26,R30
	__GETW1MN _bb0,2
	EOR  R30,R26
	EOR  R31,R27
	CALL SUBOPT_0x3
	LD   R20,X+
	LD   R21,X
;      98        if (feedback != -1)
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	CP   R30,R20
	CPC  R31,R21
	BREQ _0x21
;      99         { for (j=15-13-1; j>0; j--)
	__GETWRN 18,19,1
_0x23:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x24
;     100             if (gg[j] != -1)
	CALL SUBOPT_0x8
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x25
;     101               bb0[j] = bb0[j-1]^alpha_to[(gg[j]+feedback)%15] ;
	CALL SUBOPT_0xF
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x10
	CALL SUBOPT_0xB
	ADD  R30,R20
	ADC  R31,R21
	CALL SUBOPT_0x11
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	EOR  R30,R22
	EOR  R31,R23
	POP  R26
	POP  R27
	RJMP _0x3A1
;     102             else
_0x25:
;     103               bb0[j] = bb0[j-1] ;
	CALL SUBOPT_0xF
	MOVW R0,R30
	CALL SUBOPT_0x10
	CALL SUBOPT_0x2
	MOVW R26,R0
_0x3A1:
	ST   X+,R30
	ST   X,R31
;     104           bb0[0] = alpha_to[(gg[0]+feedback)%15] ;
	__SUBWRN 18,19,1
	RJMP _0x23
_0x24:
	MOVW R30,R20
	LDS  R26,_gg
	LDS  R27,_gg+1
	CALL SUBOPT_0x12
	RJMP _0x3A2
;     105         }
;     106        else
_0x21:
;     107         { for (j=15-13-1; j>0; j--)
	__GETWRN 18,19,1
_0x29:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x2A
;     108             bb0[j] = bb0[j-1] ;
	CALL SUBOPT_0xF
	MOVW R0,R30
	CALL SUBOPT_0x10
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     109           bb0[0] = 0 ;
	__SUBWRN 18,19,1
	RJMP _0x29
_0x2A:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x3A2:
	STS  _bb0,R30
	STS  _bb0+1,R31
;     110         } ;
;     111     } ;
	__SUBWRN 16,17,1
	RJMP _0x1F
_0x20:
;     112  }
	CALL __LOADLOCR6
	ADIW R28,6
	RET
;     113 
;     114 
;     115 void decode_rs0() {
_decode_rs0:
;     116    int i,j,u,q ;
;     117    int elp[15-13+2][15-13], d[15-13+2], l[15-13+2], u_lu[15-13+2], s[15-13+1] ;
;     118    int count=0, syn_error=0, root[1], loc[1], z[1+1], err[15], reg[1+1] ;
;     119 
;     120 /* first form the syndromes */
;     121    for (i=1; i<=15-kk; i++)
	SBIW R28,63
	SBIW R28,31
	LDI  R24,4
	LDI  R26,LOW(42)
	LDI  R27,HIGH(42)
	LDI  R30,LOW(_0x2B*2)
	LDI  R31,HIGH(_0x2B*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	u -> R20,R21
;	q -> Y+98
;	elp -> Y+82
;	d -> Y+74
;	l -> Y+66
;	u_lu -> Y+58
;	s -> Y+52
;	count -> Y+50
;	syn_error -> Y+48
;	root -> Y+46
;	loc -> Y+44
;	z -> Y+40
;	err -> Y+10
;	reg -> Y+6
	__GETWRN 16,17,1
_0x2D:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	SUB  R30,R11
	SBC  R31,R12
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0x2E
;     122     { s[i] = 0 ;
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
;     123       for (j=0; j<15; j++)
	__GETWRN 18,19,0
_0x30:
	__CPWRN 18,19,15
	BRGE _0x31
;     124         if (recd[j]!=-1)
	CALL SUBOPT_0x15
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x32
;     125           s[i] ^= alpha_to[(recd[j]+i*j)%15] ;      /* recd[j] in index form */
	CALL SUBOPT_0x13
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	CALL SUBOPT_0x12
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     126 /* convert syndrome from polynomial form to index form  */
;     127       if (s[i]!=0)  syn_error=1 ;        /* set flag if non-zero syndrome => error */
_0x32:
	__ADDWRN 18,19,1
	RJMP _0x30
_0x31:
	CALL SUBOPT_0x17
	SBIW R30,0
	BREQ _0x33
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+48,R30
	STD  Y+48+1,R31
;     128       s[i] = index_of[s[i]] ;
_0x33:
	CALL SUBOPT_0x13
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     129     } ;
	__ADDWRN 16,17,1
	RJMP _0x2D
_0x2E:
;     130 
;     131    if (syn_error)       /* if errors, try and correct */
	LDD  R30,Y+48
	LDD  R31,Y+48+1
	SBIW R30,0
	BRNE PC+3
	JMP _0x34
;     132     {
;     133 /* initialise table entries */
;     134       d[0] = 0 ;           /* index form */
	__CLRW1SX 74
;     135       d[1] = s[1] ;        /* index form */
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ADIW R30,2
	LDD  R26,Y+54
	LDD  R27,Y+54+1
	STD  Z+0,R26
	STD  Z+1,R27
;     136       elp[0][0] = 0 ;      /* index form */
	__CLRW1SX 82
;     137       elp[1][0] = 1 ;      /* polynomial form */
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 86
;     138       for (i=1; i<15-kk; i++)
	__GETWRN 16,17,1
_0x36:
	CALL SUBOPT_0x18
	BRGE _0x37
;     139         { elp[0][i] = -1 ;   /* index form */
	MOVW R30,R16
	CALL SUBOPT_0x19
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
;     140           elp[1][i] = 0 ;   /* polynomial form */
	MOVW R30,R28
	SUBI R30,LOW(-(82))
	SBCI R31,HIGH(-(82))
	ADIW R30,4
	CALL SUBOPT_0x1A
;     141         }
	__ADDWRN 16,17,1
	RJMP _0x36
_0x37:
;     142       l[0] = 0 ;
	__CLRW1SX 66
;     143       l[1] = 0 ;
	__CLRW1SX 68
;     144       u_lu[0] = -1 ;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	STD  Y+58,R30
	STD  Y+58+1,R31
;     145       u_lu[1] = 0 ;
	LDI  R30,0
	STD  Y+60,R30
	STD  Y+60+1,R30
;     146       u = 0 ;
	__GETWRN 20,21,0
;     147 
;     148       do
_0x39:
;     149       {
;     150         u++ ;
	__ADDWRN 20,21,1
;     151         if (d[u]==-1)
	CALL SUBOPT_0x1B
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x3B
;     152           { l[u+1] = l[u] ;
	CALL SUBOPT_0x1C
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     153             for (i=0; i<=l[u]; i++)
	__GETWRN 16,17,0
_0x3D:
	CALL SUBOPT_0x1D
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x3E
;     154              {  elp[u+1][i] = elp[u][i] ;
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
;     155                 elp[u][i] = index_of[elp[u][i]] ;
	CALL SUBOPT_0x21
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x1F
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     156              }
	__ADDWRN 16,17,1
	RJMP _0x3D
_0x3E:
;     157           }
;     158         else
	RJMP _0x3F
_0x3B:
;     159 /* search for words with greatest u_lu[q] for which d[q]!=0 */
;     160           { q = u-1 ;
	MOVW R30,R20
	SBIW R30,1
	__PUTW1SX 98
;     161             while ((d[q]==-1) && (q>0)) q-- ;
_0x40:
	CALL SUBOPT_0x22
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x43
	__GETW2SX 98
	CALL __CPW02
	BRLT _0x44
_0x43:
	RJMP _0x42
_0x44:
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	CALL SUBOPT_0x23
;     162 /* have found first non-zero d[q]  */
;     163             if (q>0)
	RJMP _0x40
_0x42:
	__GETW2SX 98
	CALL __CPW02
	BRGE _0x45
;     164              { j=q ;
	__GETWRSX 18,19,98
;     165                do
_0x47:
;     166                { j-- ;
	__SUBWRN 18,19,1
;     167                  if ((d[j]!=-1) && (u_lu[q]<u_lu[j]))
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x4A
	__GETW1SX 98
	MOVW R26,R28
	ADIW R26,58
	CALL SUBOPT_0x24
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,58
	CALL SUBOPT_0x2
	CP   R0,R30
	CPC  R1,R31
	BRLT _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
;     168                    q = j ;
	__PUTWSRX 18,19,98
;     169                }while (j>0) ;
_0x49:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRLT _0x47
;     170              } ;
_0x45:
;     171 
;     172 /* have now found q such that d[u]!=0 and u_lu[q] is maximum */
;     173 /* store degree of new elp polynomial */
;     174             if (l[u]>l[q]+u-q)  l[u+1] = l[u] ;
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	CALL SUBOPT_0x25
	CALL SUBOPT_0x26
	CALL SUBOPT_0x27
	CP   R30,R22
	CPC  R31,R23
	BRGE _0x4C
	CALL SUBOPT_0x1C
	MOVW R26,R0
	RJMP _0x3A3
;     175             else  l[u+1] = l[q]+u-q ;
_0x4C:
	CALL SUBOPT_0x28
	CALL SUBOPT_0x29
	CALL SUBOPT_0x26
	CALL SUBOPT_0x27
	MOVW R26,R22
_0x3A3:
	ST   X+,R30
	ST   X,R31
;     176 
;     177 /* form new elp(x) */
;     178             for (i=0; i<15-kk; i++)    elp[u+1][i] = 0 ;
	__GETWRN 16,17,0
_0x4F:
	CALL SUBOPT_0x18
	BRGE _0x50
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x14
;     179             for (i=0; i<=l[q]; i++)
	__ADDWRN 16,17,1
	RJMP _0x4F
_0x50:
	__GETWRN 16,17,0
_0x52:
	CALL SUBOPT_0x26
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x53
;     180               if (elp[q][i]!=-1)
	__GETW1SX 98
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x54
;     181                 elp[u+1][i+u-q] = alpha_to[(d[u]+15-d[q]+elp[q][i])%15] ;
	CALL SUBOPT_0x2A
	CALL __LSLW2
	CALL SUBOPT_0x2B
	__GETW2SX 98
	CALL SUBOPT_0x2C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1B
	ADIW R30,15
	MOVW R22,R30
	CALL SUBOPT_0x22
	__SUBWRR 22,23,30,31
	__GETW1SX 98
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	MOVW R26,R22
	CALL SUBOPT_0x12
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     182             for (i=0; i<=l[u]; i++)
_0x54:
	__ADDWRN 16,17,1
	RJMP _0x52
_0x53:
	__GETWRN 16,17,0
_0x56:
	CALL SUBOPT_0x1D
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x57
;     183               { elp[u+1][i] ^= elp[u][i] ;
	CALL SUBOPT_0x1E
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LD   R0,Z
	LDD  R1,Z+1
	MOVW R30,R20
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	EOR  R30,R0
	EOR  R31,R1
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     184                 elp[u][i] = index_of[elp[u][i]] ;  /*convert old elp value to index*/
	MOVW R30,R20
	CALL SUBOPT_0x21
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x1F
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     185               }
	__ADDWRN 16,17,1
	RJMP _0x56
_0x57:
;     186           }
_0x3F:
;     187         u_lu[u+1] = u-l[u+1] ;
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,58
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2E
;     188 
;     189 /* form (u+1)th discrepancy */
;     190         if (u<15-kk)    /* no discrepancy computed on last iteration */
	CALL SUBOPT_0x2F
	BRLT PC+3
	JMP _0x58
;     191           {
;     192             if (s[u+1]!=-1)
	CALL SUBOPT_0x30
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x59
;     193                    d[u+1] = alpha_to[s[u+1]] ;
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x30
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A4
;     194             else
_0x59:
;     195               d[u+1] = 0 ;
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
_0x3A4:
	ST   X+,R30
	ST   X,R31
;     196             for (i=1; i<=l[u+1]; i++)
	__GETWRN 16,17,1
_0x5C:
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x5D
;     197               if ((s[u+1-i]!=-1) && (elp[u+1][i]!=0))
	CALL SUBOPT_0x33
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x5F
	CALL SUBOPT_0x34
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE _0x60
_0x5F:
	RJMP _0x5E
_0x60:
;     198                 d[u+1] ^= alpha_to[(s[u+1-i]+index_of[elp[u+1][i]])%15] ;
	CALL SUBOPT_0x31
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x33
	CALL SUBOPT_0x24
	CALL SUBOPT_0x34
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	CALL SUBOPT_0x12
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     199             d[u+1] = index_of[d[u+1]] ;    /* put d[u+1] into index form */
_0x5E:
	__ADDWRN 16,17,1
	RJMP _0x5C
_0x5D:
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     200           }
;     201       } while ((u<15-kk) && (l[u+1]<=tt)) ;
_0x58:
	CALL SUBOPT_0x2F
	BRGE _0x61
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2
	CP   R13,R30
	CPC  R14,R31
	BRGE _0x62
_0x61:
	RJMP _0x3A
_0x62:
	RJMP _0x39
_0x3A:
;     202 
;     203       u++ ;
	__ADDWRN 20,21,1
;     204       if (l[u]<=tt)         /* can correct error */
	CALL SUBOPT_0x1D
	CP   R13,R30
	CPC  R14,R31
	BRGE PC+3
	JMP _0x63
;     205        {
;     206 /* put elp into index form */
;     207          for (i=0; i<=l[u]; i++)   elp[u][i] = index_of[elp[u][i]] ;
	__GETWRN 16,17,0
_0x65:
	CALL SUBOPT_0x1D
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x66
	MOVW R30,R20
	CALL SUBOPT_0x21
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x1F
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     208 
;     209 /* find roots of the error location polynomial */
;     210          for (i=1; i<=l[u]; i++)
	__ADDWRN 16,17,1
	RJMP _0x65
_0x66:
	__GETWRN 16,17,1
_0x68:
	CALL SUBOPT_0x1D
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x69
;     211            reg[i] = elp[u][i] ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,6
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x1F
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     212          count = 0 ;
	__ADDWRN 16,17,1
	RJMP _0x68
_0x69:
	LDI  R30,0
	STD  Y+50,R30
	STD  Y+50+1,R30
;     213          for (i=1; i<=15; i++)
	__GETWRN 16,17,1
_0x6B:
	__CPWRN 16,17,16
	BRLT PC+3
	JMP _0x6C
;     214           {  q = 1 ;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 98
;     215              for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x6E:
	CALL SUBOPT_0x1D
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x6F
;     216               if (reg[j]!=-1)
	CALL SUBOPT_0x35
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x70
;     217                 { reg[j] = (reg[j]+j)%15 ;
	CALL SUBOPT_0x36
	CALL SUBOPT_0x35
	ADD  R30,R18
	ADC  R31,R19
	CALL SUBOPT_0x11
	CALL SUBOPT_0x37
;     218                   q ^= alpha_to[reg[j]] ;
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	__GETW2SX 98
	EOR  R30,R26
	EOR  R31,R27
	__PUTW1SX 98
;     219                 } ;
_0x70:
	__ADDWRN 18,19,1
	RJMP _0x6E
_0x6F:
;     220              if (!q)        /* store root and error location number indices */
	__GETW1SX 98
	SBIW R30,0
	BRNE _0x71
;     221               { root[count] = i;
	LDD  R30,Y+50
	LDD  R31,Y+50+1
	MOVW R26,R28
	ADIW R26,46
	CALL SUBOPT_0x38
;     222                 loc[count] = 15-i ;
	LDD  R30,Y+50
	LDD  R31,Y+50+1
	MOVW R26,R28
	ADIW R26,44
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	SUB  R30,R16
	SBC  R31,R17
	ST   X+,R30
	ST   X,R31
;     223                 count++ ;
	LDD  R30,Y+50
	LDD  R31,Y+50+1
	ADIW R30,1
	STD  Y+50,R30
	STD  Y+50+1,R31
;     224               };
_0x71:
;     225           } ;
	__ADDWRN 16,17,1
	RJMP _0x6B
_0x6C:
;     226          if (count==l[u])    /* no. roots = degree of elp hence <= tt errors */
	CALL SUBOPT_0x1D
	LDD  R26,Y+50
	LDD  R27,Y+50+1
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x72
;     227           {
;     228 /* form polynomial z(x) */
;     229            for (i=1; i<=l[u]; i++)        /* Z[0] = 1 always - do not need */
	__GETWRN 16,17,1
_0x74:
	CALL SUBOPT_0x1D
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0x75
;     230             { if ((s[i]!=-1) && (elp[u][i]!=-1))
	CALL SUBOPT_0x17
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x77
	MOVW R30,R20
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x78
_0x77:
	RJMP _0x76
_0x78:
;     231                  z[i] = alpha_to[s[i]] ^ alpha_to[elp[u][i]] ;
	CALL SUBOPT_0x39
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x17
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x24
	MOVW R30,R20
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	EOR  R30,R0
	EOR  R31,R1
	POP  R26
	POP  R27
	RJMP _0x3A5
;     232               else if ((s[i]!=-1) && (elp[u][i]==-1))
_0x76:
	CALL SUBOPT_0x17
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x7B
	MOVW R30,R20
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x7C
_0x7B:
	RJMP _0x7A
_0x7C:
;     233                       z[i] = alpha_to[s[i]] ;
	CALL SUBOPT_0x39
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A5
;     234                    else if ((s[i]==-1) && (elp[u][i]!=-1))
_0x7A:
	CALL SUBOPT_0x17
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x7F
	MOVW R30,R20
	CALL SUBOPT_0x21
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x80
_0x7F:
	RJMP _0x7E
_0x80:
;     235                           z[i] = alpha_to[elp[u][i]] ;
	CALL SUBOPT_0x39
	CALL SUBOPT_0x1F
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A5
;     236                         else
_0x7E:
;     237                           z[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,40
	CALL SUBOPT_0x32
_0x3A5:
	ST   X+,R30
	ST   X,R31
;     238               for (j=1; j<i; j++)
	__GETWRN 18,19,1
_0x83:
	__CPWRR 18,19,16,17
	BRGE _0x84
;     239                 if ((s[j]!=-1) && (elp[u][i-j]!=-1))
	CALL SUBOPT_0x3A
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x86
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x87
_0x86:
	RJMP _0x85
_0x87:
;     240                    z[i] ^= alpha_to[(elp[u][i-j] + s[j])%15] ;
	CALL SUBOPT_0x39
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x24
	CALL SUBOPT_0x3A
	MOVW R26,R0
	CALL SUBOPT_0x12
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     241               z[i] = index_of[z[i]] ;         /* put into index form */
_0x85:
	__ADDWRN 18,19,1
	RJMP _0x83
_0x84:
	CALL SUBOPT_0x39
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,40
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     242             } ;
	__ADDWRN 16,17,1
	RJMP _0x74
_0x75:
;     243 
;     244   /* evaluate errors at locations given by error location numbers loc[i] */
;     245            for (i=0; i<15; i++)
	__GETWRN 16,17,0
_0x89:
	__CPWRN 16,17,15
	BRGE _0x8A
;     246              { err[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,10
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     247                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x8B
;     248                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A6
;     249                else  recd[i] = 0 ;
_0x8B:
	CALL SUBOPT_0x3E
_0x3A6:
	ST   X+,R30
	ST   X,R31
;     250              }
	__ADDWRN 16,17,1
	RJMP _0x89
_0x8A:
;     251            for (i=0; i<l[u]; i++)    /* compute numerator of error term first */
	__GETWRN 16,17,0
_0x8E:
	CALL SUBOPT_0x1D
	CP   R16,R30
	CPC  R17,R31
	BRLT PC+3
	JMP _0x8F
;     252             { err[loc[i]] = 1;       /* accounts for z[0] */
	CALL SUBOPT_0x3F
	MOVW R26,R28
	ADIW R26,10
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x7
;     253               for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x91:
	CALL SUBOPT_0x1D
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x92
;     254                 if (z[j]!=-1)
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,40
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x93
;     255                   err[loc[i]] ^= alpha_to[(z[j]+j*root[i])%15] ;
	CALL SUBOPT_0x3F
	MOVW R26,R28
	ADIW R26,10
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,40
	CALL SUBOPT_0x25
	CALL SUBOPT_0x40
	CALL SUBOPT_0x41
	CALL SUBOPT_0x12
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     256               if (err[loc[i]]!=0)
_0x93:
	__ADDWRN 18,19,1
	RJMP _0x91
_0x92:
	CALL SUBOPT_0x3F
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE PC+3
	JMP _0x94
;     257                { err[loc[i]] = index_of[err[loc[i]]] ;
	CALL SUBOPT_0x3F
	MOVW R26,R28
	ADIW R26,10
	LSL  R30
	ROL  R31
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     258                  q = 0 ;     /* form denominator of error term */
	__CLRW1SX 98
;     259                  for (j=0; j<l[u]; j++)
	__GETWRN 18,19,0
_0x96:
	CALL SUBOPT_0x1D
	CP   R18,R30
	CPC  R19,R31
	BRGE _0x97
;     260                    if (j!=i)
	__CPWRR 16,17,18,19
	BREQ _0x98
;     261                      q += index_of[1^alpha_to[(loc[j]+root[i])%15]] ;
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x24
	CALL SUBOPT_0x40
	MOVW R26,R0
	CALL SUBOPT_0x12
	CALL SUBOPT_0x42
	__GETW2SX 98
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1SX 98
;     262                  q = q % 15 ;
_0x98:
	__ADDWRN 18,19,1
	RJMP _0x96
_0x97:
	__GETW2SX 98
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL __MODW21
	__PUTW1SX 98
;     263                  err[loc[i]] = alpha_to[(err[loc[i]]-q+15)%15] ;
	CALL SUBOPT_0x3F
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x29
	CALL SUBOPT_0x3F
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x2
	__GETW2SX 98
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,15
	CALL SUBOPT_0x11
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     264                  recd[loc[i]] ^= err[loc[i]] ;  /*recd[i] must be in polynomial form */
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x43
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x2
	CALL SUBOPT_0x44
;     265                }
;     266             }
_0x94:
	__ADDWRN 16,17,1
	RJMP _0x8E
_0x8F:
;     267           }
;     268          else {   /* no. roots != degree of elp => >tt errors and cannot solve */
	RJMP _0x99
_0x72:
;     269            chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     270            for (i=0; i<15; i++)        /* could return error flag if desired */
	__GETWRN 16,17,0
_0x9B:
	__CPWRN 16,17,15
	BRGE _0x9C
;     271                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x9D
;     272                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A7
;     273                else  recd[i] = 0 ;     /* just output received codeword as is */
_0x9D:
	CALL SUBOPT_0x3E
_0x3A7:
	ST   X+,R30
	ST   X,R31
;     274          };      
	__ADDWRN 16,17,1
	RJMP _0x9B
_0x9C:
_0x99:
;     275        }
;     276      else {         /* elp has degree has degree >tt hence cannot solve */
	RJMP _0x9F
_0x63:
;     277        chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     278        for (i=0; i<15; i++)       /* could return error flag if desired */
	__GETWRN 16,17,0
_0xA1:
	__CPWRN 16,17,15
	BRGE _0xA2
;     279           if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xA3
;     280             recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A8
;     281           else  recd[i] = 0 ;     /* just output received codeword as is */
_0xA3:
	CALL SUBOPT_0x3E
_0x3A8:
	ST   X+,R30
	ST   X,R31
;     282        };   
	__ADDWRN 16,17,1
	RJMP _0xA1
_0xA2:
_0x9F:
;     283     }
;     284    else       /* no non-zero syndromes => no errors: output received codeword */
	RJMP _0xA5
_0x34:
;     285     for (i=0; i<15; i++)
	__GETWRN 16,17,0
_0xA7:
	__CPWRN 16,17,15
	BRGE _0xA8
;     286        if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xA9
;     287          recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3A9
;     288        else  recd[i] = 0 ;
_0xA9:
	CALL SUBOPT_0x3E
_0x3A9:
	ST   X+,R30
	ST   X,R31
;     289  }
	__ADDWRN 16,17,1
	RJMP _0xA7
_0xA8:
_0xA5:
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,37
	RET
;     290  
;     291 void decode_rs1() {
_decode_rs1:
;     292    int i,j,u,q ;
;     293    int elp[15-11+2][15-11], d[15-11+2], l[15-11+2], u_lu[15-11+2], s[15-11+1] ;
;     294    int count=0, syn_error=0, root[2], loc[2], z[2+1], err[15], reg[2+1] ;
;     295 
;     296    for (i=1; i<=nn-kk; i++)
	SBIW R28,63
	SBIW R28,63
	SBIW R28,24
	LDI  R24,4
	LDI  R26,LOW(50)
	LDI  R27,HIGH(50)
	LDI  R30,LOW(_0xAB*2)
	LDI  R31,HIGH(_0xAB*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	u -> R20,R21
;	q -> Y+154
;	elp -> Y+106
;	d -> Y+94
;	l -> Y+82
;	u_lu -> Y+70
;	s -> Y+60
;	count -> Y+58
;	syn_error -> Y+56
;	root -> Y+52
;	loc -> Y+48
;	z -> Y+42
;	err -> Y+12
;	reg -> Y+6
	__GETWRN 16,17,1
_0xAD:
	CALL SUBOPT_0x45
	BRGE PC+3
	JMP _0xAE
;     297     { s[i] = 0 ;
	CALL SUBOPT_0x46
	CALL SUBOPT_0x14
;     298       for (j=0; j<nn; j++)
	__GETWRN 18,19,0
_0xB0:
	__CPWRR 18,19,7,8
	BRGE _0xB1
;     299         if (recd[j]!=-1)
	CALL SUBOPT_0x15
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xB2
;     300           s[i] ^= alpha_to[(recd[j]+i*j)%nn] ;      /* recd[j] in index form */
	CALL SUBOPT_0x46
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     301       if (s[i]!=0)  syn_error=1 ;        /* set flag if non-zero syndrome => error */
_0xB2:
	__ADDWRN 18,19,1
	RJMP _0xB0
_0xB1:
	CALL SUBOPT_0x48
	SBIW R30,0
	BREQ _0xB3
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+56,R30
	STD  Y+56+1,R31
;     302       s[i] = index_of[s[i]] ;
_0xB3:
	CALL SUBOPT_0x46
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,60
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     303     } ;
	__ADDWRN 16,17,1
	RJMP _0xAD
_0xAE:
;     304 
;     305    if (syn_error)       /* if errors, try and correct */
	LDD  R30,Y+56
	LDD  R31,Y+56+1
	SBIW R30,0
	BRNE PC+3
	JMP _0xB4
;     306     {
;     307       d[0] = 0 ;           /* index form */
	__CLRW1SX 94
;     308       d[1] = s[1] ;        /* index form */
	MOVW R30,R28
	SUBI R30,LOW(-(94))
	SBCI R31,HIGH(-(94))
	ADIW R30,2
	LDD  R26,Y+62
	LDD  R27,Y+62+1
	STD  Z+0,R26
	STD  Z+1,R27
;     309       elp[0][0] = 0 ;      /* index form */
	__CLRW1SX 106
;     310       elp[1][0] = 1 ;      /* polynomial form */
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 114
;     311       for (i=1; i<nn-kk; i++)
	__GETWRN 16,17,1
_0xB6:
	CALL SUBOPT_0x49
	BRGE _0xB7
;     312         { elp[0][i] = -1 ;   /* index form */
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	CALL SUBOPT_0x4A
;     313           elp[1][i] = 0 ;   /* polynomial form */
	MOVW R30,R28
	SUBI R30,LOW(-(106))
	SBCI R31,HIGH(-(106))
	ADIW R30,8
	CALL SUBOPT_0x1A
;     314         }
	__ADDWRN 16,17,1
	RJMP _0xB6
_0xB7:
;     315       l[0] = 0 ;
	__CLRW1SX 82
;     316       l[1] = 0 ;
	__CLRW1SX 84
;     317       u_lu[0] = -1 ;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	__PUTW1SX 70
;     318       u_lu[1] = 0 ;
	__CLRW1SX 72
;     319       u = 0 ;
	__GETWRN 20,21,0
;     320 
;     321       do
_0xB9:
;     322       {
;     323         u++ ;
	__ADDWRN 20,21,1
;     324         if (d[u]==-1)
	CALL SUBOPT_0x4B
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0xBB
;     325           { l[u+1] = l[u] ;
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4C
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     326             for (i=0; i<=l[u]; i++)
	__GETWRN 16,17,0
_0xBD:
	CALL SUBOPT_0x4C
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xBE
;     327              {  elp[u+1][i] = elp[u][i] ;
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x20
;     328                 elp[u][i] = index_of[elp[u][i]] ;
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4E
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     329              }
	__ADDWRN 16,17,1
	RJMP _0xBD
_0xBE:
;     330           }
;     331         else
	RJMP _0xBF
_0xBB:
;     332           { q = u-1 ;
	MOVW R30,R20
	SBIW R30,1
	__PUTW1SX 154
;     333             while ((d[q]==-1) && (q>0)) q-- ;
_0xC0:
	CALL SUBOPT_0x50
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0xC3
	__GETW2SX 154
	CALL __CPW02
	BRLT _0xC4
_0xC3:
	RJMP _0xC2
_0xC4:
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	CALL SUBOPT_0x23
;     334             if (q>0)
	RJMP _0xC0
_0xC2:
	__GETW2SX 154
	CALL __CPW02
	BRGE _0xC5
;     335              { j=q ;
	__GETWRSX 18,19,154
;     336                do
_0xC7:
;     337                { j-- ;
	__SUBWRN 18,19,1
;     338                  if ((d[j]!=-1) && (u_lu[q]<u_lu[j]))
	CALL SUBOPT_0x51
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xCA
	__GETW1SX 154
	MOVW R26,R28
	SUBI R26,LOW(-(70))
	SBCI R27,HIGH(-(70))
	CALL SUBOPT_0x24
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(70))
	SBCI R27,HIGH(-(70))
	CALL SUBOPT_0x2
	CP   R0,R30
	CPC  R1,R31
	BRLT _0xCB
_0xCA:
	RJMP _0xC9
_0xCB:
;     339                    q = j ;
	__PUTWSRX 18,19,154
;     340                }while (j>0) ;
_0xC9:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRLT _0xC7
;     341              } ;
_0xC5:
;     342 
;     343             if (l[u]>l[q]+u-q)  l[u+1] = l[u] ;
	MOVW R30,R20
	CALL SUBOPT_0x19
	LD   R22,X+
	LD   R23,X
	CALL SUBOPT_0x52
	CALL SUBOPT_0x53
	CP   R30,R22
	CPC  R31,R23
	BRGE _0xCC
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4C
	MOVW R26,R0
	RJMP _0x3AA
;     344             else  l[u+1] = l[q]+u-q ;
_0xCC:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x29
	CALL SUBOPT_0x52
	CALL SUBOPT_0x53
	MOVW R26,R22
_0x3AA:
	ST   X+,R30
	ST   X,R31
;     345 
;     346             for (i=0; i<nn-kk; i++)    elp[u+1][i] = 0 ;
	__GETWRN 16,17,0
_0xCF:
	CALL SUBOPT_0x49
	BRGE _0xD0
	CALL SUBOPT_0x4D
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     347             for (i=0; i<=l[q]; i++)
	__ADDWRN 16,17,1
	RJMP _0xCF
_0xD0:
	__GETWRN 16,17,0
_0xD2:
	CALL SUBOPT_0x52
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0xD3
;     348               if (elp[q][i]!=-1)
	__GETW1SX 154
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xD4
;     349                 elp[u+1][i+u-q] = alpha_to[(d[u]+nn-d[q]+elp[q][i])%nn] ;
	MOVW R30,R20
	ADIW R30,1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	CALL SUBOPT_0x2B
	__GETW2SX 154
	CALL SUBOPT_0x2C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4B
	ADD  R30,R7
	ADC  R31,R8
	MOVW R22,R30
	CALL SUBOPT_0x50
	__SUBWRR 22,23,30,31
	__GETW1SX 154
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x2
	MOVW R26,R22
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     350             for (i=0; i<=l[u]; i++)
_0xD4:
	__ADDWRN 16,17,1
	RJMP _0xD2
_0xD3:
	__GETWRN 16,17,0
_0xD6:
	CALL SUBOPT_0x4C
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xD7
;     351               { elp[u+1][i] ^= elp[u][i] ;
	CALL SUBOPT_0x4D
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LD   R0,Z
	LDD  R1,Z+1
	CALL SUBOPT_0x4E
	EOR  R30,R0
	EOR  R31,R1
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     352                 elp[u][i] = index_of[elp[u][i]] ;  /*convert old elp value to index*/
	MOVW R30,R20
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4E
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     353               }
	__ADDWRN 16,17,1
	RJMP _0xD6
_0xD7:
;     354           }
_0xBF:
;     355         u_lu[u+1] = u-l[u+1] ;
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(70))
	SBCI R27,HIGH(-(70))
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2E
;     356 
;     357         if (u<nn-kk)    /* no discrepancy computed on last iteration */
	CALL SUBOPT_0x54
	BRLT PC+3
	JMP _0xD8
;     358           {
;     359             if (s[u+1]!=-1)
	CALL SUBOPT_0x55
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xD9
;     360                    d[u+1] = alpha_to[s[u+1]] ;
	CALL SUBOPT_0x56
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x55
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3AB
;     361             else
_0xD9:
;     362               d[u+1] = 0 ;
	CALL SUBOPT_0x56
	CALL SUBOPT_0x32
_0x3AB:
	ST   X+,R30
	ST   X,R31
;     363             for (i=1; i<=l[u+1]; i++)
	__GETWRN 16,17,1
_0xDC:
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xDD
;     364               if ((s[u+1-i]!=-1) && (elp[u+1][i]!=0))
	CALL SUBOPT_0x57
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xDF
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE _0xE0
_0xDF:
	RJMP _0xDE
_0xE0:
;     365                 d[u+1] ^= alpha_to[(s[u+1-i]+index_of[elp[u+1][i]])%nn] ;
	CALL SUBOPT_0x56
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x57
	CALL SUBOPT_0x24
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     366             d[u+1] = index_of[d[u+1]] ;    /* put d[u+1] into index form */
_0xDE:
	__ADDWRN 16,17,1
	RJMP _0xDC
_0xDD:
	CALL SUBOPT_0x56
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x56
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     367           }
;     368       } while ((u<nn-kk) && (l[u+1]<=tt)) ;
_0xD8:
	CALL SUBOPT_0x54
	BRGE _0xE1
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2
	CP   R13,R30
	CPC  R14,R31
	BRGE _0xE2
_0xE1:
	RJMP _0xBA
_0xE2:
	RJMP _0xB9
_0xBA:
;     369 
;     370       u++ ;
	__ADDWRN 20,21,1
;     371       if (l[u]<=tt)         /* can correct error */
	CALL SUBOPT_0x4C
	CP   R13,R30
	CPC  R14,R31
	BRGE PC+3
	JMP _0xE3
;     372        {
;     373          for (i=0; i<=l[u]; i++)   elp[u][i] = index_of[elp[u][i]] ;
	__GETWRN 16,17,0
_0xE5:
	CALL SUBOPT_0x4C
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xE6
	MOVW R30,R20
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4E
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     374 
;     375          for (i=1; i<=l[u]; i++)
	__ADDWRN 16,17,1
	RJMP _0xE5
_0xE6:
	__GETWRN 16,17,1
_0xE8:
	CALL SUBOPT_0x4C
	CP   R30,R16
	CPC  R31,R17
	BRLT _0xE9
;     376            reg[i] = elp[u][i] ;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x4E
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     377          count = 0 ;
	__ADDWRN 16,17,1
	RJMP _0xE8
_0xE9:
	LDI  R30,0
	STD  Y+58,R30
	STD  Y+58+1,R30
;     378          for (i=1; i<=nn; i++)
	__GETWRN 16,17,1
_0xEB:
	__CPWRR 7,8,16,17
	BRGE PC+3
	JMP _0xEC
;     379           {  q = 1 ;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 154
;     380              for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0xEE:
	CALL SUBOPT_0x4C
	CP   R30,R18
	CPC  R31,R19
	BRLT _0xEF
;     381               if (reg[j]!=-1)
	CALL SUBOPT_0x35
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xF0
;     382                 { reg[j] = (reg[j]+j)%nn ;
	CALL SUBOPT_0x36
	CALL SUBOPT_0x35
	CALL SUBOPT_0x59
;     383                   q ^= alpha_to[reg[j]] ;
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	__GETW2SX 154
	EOR  R30,R26
	EOR  R31,R27
	__PUTW1SX 154
;     384                 } ;
_0xF0:
	__ADDWRN 18,19,1
	RJMP _0xEE
_0xEF:
;     385              if (!q)        /* store root and error location number indices */
	__GETW1SX 154
	SBIW R30,0
	BRNE _0xF1
;     386               { root[count] = i;
	LDD  R30,Y+58
	LDD  R31,Y+58+1
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x38
;     387                 loc[count] = nn-i ;
	LDD  R30,Y+58
	LDD  R31,Y+58+1
	MOVW R26,R28
	ADIW R26,48
	CALL SUBOPT_0x5A
;     388                 count++ ;
	LDD  R30,Y+58
	LDD  R31,Y+58+1
	ADIW R30,1
	STD  Y+58,R30
	STD  Y+58+1,R31
;     389               };
_0xF1:
;     390           } ;
	__ADDWRN 16,17,1
	RJMP _0xEB
_0xEC:
;     391          if (count==l[u])    /* no. roots = degree of elp hence <= tt errors */
	CALL SUBOPT_0x4C
	LDD  R26,Y+58
	LDD  R27,Y+58+1
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0xF2
;     392           {
;     393            for (i=1; i<=l[u]; i++)        /* Z[0] = 1 always - do not need */
	__GETWRN 16,17,1
_0xF4:
	CALL SUBOPT_0x4C
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0xF5
;     394             { if ((s[i]!=-1) && (elp[u][i]!=-1))
	CALL SUBOPT_0x48
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xF7
	CALL SUBOPT_0x4E
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0xF8
_0xF7:
	RJMP _0xF6
_0xF8:
;     395                  z[i] = alpha_to[s[i]] ^ alpha_to[elp[u][i]] ;
	CALL SUBOPT_0x5B
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x48
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x24
	CALL SUBOPT_0x4E
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	EOR  R30,R0
	EOR  R31,R1
	POP  R26
	POP  R27
	RJMP _0x3AC
;     396               else if ((s[i]!=-1) && (elp[u][i]==-1))
_0xF6:
	CALL SUBOPT_0x48
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xFB
	CALL SUBOPT_0x4E
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0xFC
_0xFB:
	RJMP _0xFA
_0xFC:
;     397                       z[i] = alpha_to[s[i]] ;
	CALL SUBOPT_0x5B
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,60
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3AC
;     398                    else if ((s[i]==-1) && (elp[u][i]!=-1))
_0xFA:
	CALL SUBOPT_0x48
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0xFF
	CALL SUBOPT_0x4E
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x100
_0xFF:
	RJMP _0xFE
_0x100:
;     399                           z[i] = alpha_to[elp[u][i]] ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,42
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x4E
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3AC
;     400                         else
_0xFE:
;     401                           z[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,42
	CALL SUBOPT_0x32
_0x3AC:
	ST   X+,R30
	ST   X,R31
;     402               for (j=1; j<i; j++)
	__GETWRN 18,19,1
_0x103:
	__CPWRR 18,19,16,17
	BRGE _0x104
;     403                 if ((s[j]!=-1) && (elp[u][i-j]!=-1))
	CALL SUBOPT_0x5C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x106
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x107
_0x106:
	RJMP _0x105
_0x107:
;     404                    z[i] ^= alpha_to[(elp[u][i-j] + s[j])%nn] ;
	CALL SUBOPT_0x5B
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x24
	CALL SUBOPT_0x5C
	MOVW R26,R0
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     405               z[i] = index_of[z[i]] ;         /* put into index form */
_0x105:
	__ADDWRN 18,19,1
	RJMP _0x103
_0x104:
	CALL SUBOPT_0x5B
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,42
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     406             } ;
	__ADDWRN 16,17,1
	RJMP _0xF4
_0xF5:
;     407 
;     408            for (i=0; i<nn; i++)
	__GETWRN 16,17,0
_0x109:
	__CPWRR 16,17,7,8
	BRGE _0x10A
;     409              { err[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,12
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     410                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x10B
;     411                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3AD
;     412                else  recd[i] = 0 ;
_0x10B:
	CALL SUBOPT_0x3E
_0x3AD:
	ST   X+,R30
	ST   X,R31
;     413              }
	__ADDWRN 16,17,1
	RJMP _0x109
_0x10A:
;     414            for (i=0; i<l[u]; i++)    /* compute numerator of error term first */
	__GETWRN 16,17,0
_0x10E:
	CALL SUBOPT_0x4C
	CP   R16,R30
	CPC  R17,R31
	BRLT PC+3
	JMP _0x10F
;     415             { err[loc[i]] = 1;       /* accounts for z[0] */
	CALL SUBOPT_0x5E
	MOVW R26,R28
	ADIW R26,12
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x7
;     416               for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x111:
	CALL SUBOPT_0x4C
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x112
;     417                 if (z[j]!=-1)
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,42
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x113
;     418                   err[loc[i]] ^= alpha_to[(z[j]+j*root[i])%nn] ;
	CALL SUBOPT_0x5E
	MOVW R26,R28
	ADIW R26,12
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,42
	CALL SUBOPT_0x25
	CALL SUBOPT_0x17
	CALL SUBOPT_0x41
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     419               if (err[loc[i]]!=0)
_0x113:
	__ADDWRN 18,19,1
	RJMP _0x111
_0x112:
	CALL SUBOPT_0x5E
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE PC+3
	JMP _0x114
;     420                { err[loc[i]] = index_of[err[loc[i]]] ;
	CALL SUBOPT_0x5E
	MOVW R26,R28
	ADIW R26,12
	LSL  R30
	ROL  R31
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,48
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     421                  q = 0 ;     /* form denominator of error term */
	__CLRW1SX 154
;     422                  for (j=0; j<l[u]; j++)
	__GETWRN 18,19,0
_0x116:
	CALL SUBOPT_0x4C
	CP   R18,R30
	CPC  R19,R31
	BRGE _0x117
;     423                    if (j!=i)
	__CPWRR 16,17,18,19
	BREQ _0x118
;     424                      q += index_of[1^alpha_to[(loc[j]+root[i])%nn]] ;
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,48
	CALL SUBOPT_0x24
	CALL SUBOPT_0x17
	MOVW R26,R0
	CALL SUBOPT_0x47
	CALL SUBOPT_0x42
	__GETW2SX 154
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1SX 154
;     425                  q = q % nn ;
_0x118:
	__ADDWRN 18,19,1
	RJMP _0x116
_0x117:
	__GETW1R 7,8
	__GETW2SX 154
	CALL __MODW21
	__PUTW1SX 154
;     426                  err[loc[i]] = alpha_to[(err[loc[i]]-q+nn)%nn] ;
	CALL SUBOPT_0x5E
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x29
	CALL SUBOPT_0x5E
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x2
	__GETW2SX 154
	CALL SUBOPT_0x5F
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     427                  recd[loc[i]] ^= err[loc[i]] ;  /*recd[i] must be in polynomial form */
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x43
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x2
	CALL SUBOPT_0x44
;     428                }
;     429             }
_0x114:
	__ADDWRN 16,17,1
	RJMP _0x10E
_0x10F:
;     430           }
;     431          else {   /* no. roots != degree of elp => >tt errors and cannot solve */
	RJMP _0x119
_0xF2:
;     432            chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     433            for (i=0; i<nn; i++)        /* could return error flag if desired */
	__GETWRN 16,17,0
_0x11B:
	__CPWRR 16,17,7,8
	BRGE _0x11C
;     434                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x11D
;     435                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3AE
;     436                else  recd[i] = 0 ;     /* just output received codeword as is */
_0x11D:
	CALL SUBOPT_0x3E
_0x3AE:
	ST   X+,R30
	ST   X,R31
;     437           }     
	__ADDWRN 16,17,1
	RJMP _0x11B
_0x11C:
_0x119:
;     438        }
;     439      else  {       /* elp has degree has degree >tt hence cannot solve */
	RJMP _0x11F
_0xE3:
;     440        chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     441        for (i=0; i<nn; i++)       /* could return error flag if desired */
	__GETWRN 16,17,0
_0x121:
	__CPWRR 16,17,7,8
	BRGE _0x122
;     442           if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x123
;     443             recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3AF
;     444           else  recd[i] = 0 ;     /* just output received codeword as is */
_0x123:
	CALL SUBOPT_0x3E
_0x3AF:
	ST   X+,R30
	ST   X,R31
;     445        }   
	__ADDWRN 16,17,1
	RJMP _0x121
_0x122:
_0x11F:
;     446     }
;     447    else       /* no non-zero syndromes => no errors: output received codeword */
	RJMP _0x125
_0xB4:
;     448     for (i=0; i<nn; i++)
	__GETWRN 16,17,0
_0x127:
	__CPWRR 16,17,7,8
	BRGE _0x128
;     449        if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x129
;     450          recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B0
;     451        else  recd[i] = 0 ;
_0x129:
	CALL SUBOPT_0x3E
_0x3B0:
	ST   X+,R30
	ST   X,R31
;     452  } 
	__ADDWRN 16,17,1
	RJMP _0x127
_0x128:
_0x125:
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,30
	RET
;     453  
;     454 void decode_rs2() {
_decode_rs2:
;     455    int i,j,u,q ;
;     456    int elp[15-9+2][15-9], d[15-9+2], l[15-9+2], u_lu[15-9+2], s[15-9+1] ;
;     457    int count=0, syn_error=0, root[3], loc[3], z[3+1], err[15], reg[3+1] ;
;     458 
;     459    for (i=1; i<=nn-kk; i++)
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,33
	LDI  R24,4
	LDI  R26,LOW(58)
	LDI  R27,HIGH(58)
	LDI  R30,LOW(_0x12B*2)
	LDI  R31,HIGH(_0x12B*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	u -> R20,R21
;	q -> Y+226
;	elp -> Y+130
;	d -> Y+114
;	l -> Y+98
;	u_lu -> Y+82
;	s -> Y+68
;	count -> Y+66
;	syn_error -> Y+64
;	root -> Y+58
;	loc -> Y+52
;	z -> Y+44
;	err -> Y+14
;	reg -> Y+6
	__GETWRN 16,17,1
_0x12D:
	CALL SUBOPT_0x45
	BRGE PC+3
	JMP _0x12E
;     460     { s[i] = 0 ;
	CALL SUBOPT_0x60
	CALL SUBOPT_0x14
;     461       for (j=0; j<nn; j++)
	__GETWRN 18,19,0
_0x130:
	__CPWRR 18,19,7,8
	BRGE _0x131
;     462         if (recd[j]!=-1)
	CALL SUBOPT_0x15
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x132
;     463           s[i] ^= alpha_to[(recd[j]+i*j)%nn] ;      /* recd[j] in index form */
	CALL SUBOPT_0x60
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     464       if (s[i]!=0)  syn_error=1 ;        /* set flag if non-zero syndrome => error */
_0x132:
	__ADDWRN 18,19,1
	RJMP _0x130
_0x131:
	CALL SUBOPT_0x61
	SBIW R30,0
	BREQ _0x133
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 64
;     465       s[i] = index_of[s[i]] ;
_0x133:
	CALL SUBOPT_0x60
	CALL SUBOPT_0xD
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     466     } ;
	__ADDWRN 16,17,1
	RJMP _0x12D
_0x12E:
;     467 
;     468    if (syn_error)       /* if errors, try and correct */
	__GETW1SX 64
	SBIW R30,0
	BRNE PC+3
	JMP _0x134
;     469     {
;     470       d[0] = 0 ;           /* index form */
	__CLRW1SX 114
;     471       d[1] = s[1] ;        /* index form */
	MOVW R30,R28
	SUBI R30,LOW(-(114))
	SBCI R31,HIGH(-(114))
	ADIW R30,2
	__GETW2SX 70
	STD  Z+0,R26
	STD  Z+1,R27
;     472       elp[0][0] = 0 ;      /* index form */
	__CLRW1SX 130
;     473       elp[1][0] = 1 ;      /* polynomial form */
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 142
;     474       for (i=1; i<nn-kk; i++)
	__GETWRN 16,17,1
_0x136:
	CALL SUBOPT_0x49
	BRGE _0x137
;     475         { elp[0][i] = -1 ;   /* index form */
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(130))
	SBCI R27,HIGH(-(130))
	CALL SUBOPT_0x4A
;     476           elp[1][i] = 0 ;   /* polynomial form */
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ADIW R30,12
	CALL SUBOPT_0x1A
;     477         }
	__ADDWRN 16,17,1
	RJMP _0x136
_0x137:
;     478       l[0] = 0 ;
	__CLRW1SX 98
;     479       l[1] = 0 ;
	__CLRW1SX 100
;     480       u_lu[0] = -1 ;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	__PUTW1SX 82
;     481       u_lu[1] = 0 ;
	__CLRW1SX 84
;     482       u = 0 ;
	__GETWRN 20,21,0
;     483 
;     484       do
_0x139:
;     485       {
;     486         u++ ;
	__ADDWRN 20,21,1
;     487         if (d[u]==-1)
	CALL SUBOPT_0x62
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x13B
;     488           { l[u+1] = l[u] ;
	CALL SUBOPT_0x63
	CALL SUBOPT_0x64
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     489             for (i=0; i<=l[u]; i++)
	__GETWRN 16,17,0
_0x13D:
	CALL SUBOPT_0x64
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x13E
;     490              {  elp[u+1][i] = elp[u][i] ;
	CALL SUBOPT_0x65
	CALL SUBOPT_0x29
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     491                 elp[u][i] = index_of[elp[u][i]] ;
	CALL SUBOPT_0x66
	CALL SUBOPT_0x29
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     492              }
	__ADDWRN 16,17,1
	RJMP _0x13D
_0x13E:
;     493           }
;     494         else
	RJMP _0x13F
_0x13B:
;     495           { q = u-1 ;
	MOVW R30,R20
	SBIW R30,1
	__PUTW1SX 226
;     496             while ((d[q]==-1) && (q>0)) q-- ;
_0x140:
	CALL SUBOPT_0x67
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x143
	__GETW2SX 226
	CALL __CPW02
	BRLT _0x144
_0x143:
	RJMP _0x142
_0x144:
	MOVW R26,R28
	SUBI R26,LOW(-(226))
	SBCI R27,HIGH(-(226))
	CALL SUBOPT_0x23
;     497             if (q>0)
	RJMP _0x140
_0x142:
	__GETW2SX 226
	CALL __CPW02
	BRGE _0x145
;     498              { j=q ;
	__GETWRSX 18,19,226
;     499                do
_0x147:
;     500                { j-- ;
	__SUBWRN 18,19,1
;     501                  if ((d[j]!=-1) && (u_lu[q]<u_lu[j]))
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(114))
	SBCI R27,HIGH(-(114))
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x14A
	__GETW1SX 226
	CALL SUBOPT_0x19
	LD   R0,X+
	LD   R1,X
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	CALL SUBOPT_0x2
	CP   R0,R30
	CPC  R1,R31
	BRLT _0x14B
_0x14A:
	RJMP _0x149
_0x14B:
;     502                    q = j ;
	__PUTWSRX 18,19,226
;     503                }while (j>0) ;
_0x149:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRLT _0x147
;     504              } ;
_0x145:
;     505 
;     506             if (l[u]>l[q]+u-q)  l[u+1] = l[u] ;
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	CALL SUBOPT_0x25
	CALL SUBOPT_0x68
	CALL SUBOPT_0x69
	CP   R30,R22
	CPC  R31,R23
	BRGE _0x14C
	CALL SUBOPT_0x63
	CALL SUBOPT_0x64
	MOVW R26,R0
	RJMP _0x3B1
;     507             else  l[u+1] = l[q]+u-q ;
_0x14C:
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x29
	CALL SUBOPT_0x68
	CALL SUBOPT_0x69
	MOVW R26,R22
_0x3B1:
	ST   X+,R30
	ST   X,R31
;     508 
;     509             for (i=0; i<nn-kk; i++)    elp[u+1][i] = 0 ;
	__GETWRN 16,17,0
_0x14F:
	CALL SUBOPT_0x49
	BRGE _0x150
	CALL SUBOPT_0x65
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     510             for (i=0; i<=l[q]; i++)
	__ADDWRN 16,17,1
	RJMP _0x14F
_0x150:
	__GETWRN 16,17,0
_0x152:
	CALL SUBOPT_0x68
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x153
;     511               if (elp[q][i]!=-1)
	CALL SUBOPT_0x6B
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x154
;     512                 elp[u+1][i+u-q] = alpha_to[(d[u]+nn-d[q]+elp[q][i])%nn] ;
	MOVW R30,R20
	ADIW R30,1
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x2B
	__GETW2SX 226
	CALL SUBOPT_0x2C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x62
	ADD  R30,R7
	ADC  R31,R8
	MOVW R22,R30
	CALL SUBOPT_0x67
	__SUBWRR 22,23,30,31
	CALL SUBOPT_0x6B
	MOVW R26,R22
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     513             for (i=0; i<=l[u]; i++)
_0x154:
	__ADDWRN 16,17,1
	RJMP _0x152
_0x153:
	__GETWRN 16,17,0
_0x156:
	CALL SUBOPT_0x64
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x157
;     514               { elp[u+1][i] ^= elp[u][i] ;
	CALL SUBOPT_0x65
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LD   R22,Z
	LDD  R23,Z+1
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	EOR  R30,R22
	EOR  R31,R23
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     515                 elp[u][i] = index_of[elp[u][i]] ;  /*convert old elp value to index*/
	CALL SUBOPT_0x66
	CALL SUBOPT_0x29
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     516               }
	__ADDWRN 16,17,1
	RJMP _0x156
_0x157:
;     517           }
_0x13F:
;     518         u_lu[u+1] = u-l[u+1] ;
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2E
;     519 
;     520         if (u<nn-kk)    /* no discrepancy computed on last iteration */
	CALL SUBOPT_0x54
	BRLT PC+3
	JMP _0x158
;     521           {
;     522             if (s[u+1]!=-1)
	CALL SUBOPT_0x6D
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x159
;     523                    d[u+1] = alpha_to[s[u+1]] ;
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x6D
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B2
;     524             else
_0x159:
;     525               d[u+1] = 0 ;
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x32
_0x3B2:
	ST   X+,R30
	ST   X,R31
;     526             for (i=1; i<=l[u+1]; i++)
	__GETWRN 16,17,1
_0x15C:
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x2
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x15D
;     527               if ((s[u+1-i]!=-1) && (elp[u+1][i]!=0))
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x15F
	CALL SUBOPT_0x65
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE _0x160
_0x15F:
	RJMP _0x15E
_0x160:
;     528                 d[u+1] ^= alpha_to[(s[u+1-i]+index_of[elp[u+1][i]])%nn] ;
	CALL SUBOPT_0x6E
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x25
	CALL SUBOPT_0x65
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R22
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     529             d[u+1] = index_of[d[u+1]] ;    /* put d[u+1] into index form */
_0x15E:
	__ADDWRN 16,17,1
	RJMP _0x15C
_0x15D:
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     530           }
;     531       } while ((u<nn-kk) && (l[u+1]<=tt)) ;
_0x158:
	CALL SUBOPT_0x54
	BRGE _0x161
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x2
	CP   R13,R30
	CPC  R14,R31
	BRGE _0x162
_0x161:
	RJMP _0x13A
_0x162:
	RJMP _0x139
_0x13A:
;     532 
;     533       u++ ;
	__ADDWRN 20,21,1
;     534       if (l[u]<=tt)         /* can correct error */
	CALL SUBOPT_0x64
	CP   R13,R30
	CPC  R14,R31
	BRGE PC+3
	JMP _0x163
;     535        {
;     536          for (i=0; i<=l[u]; i++)   elp[u][i] = index_of[elp[u][i]] ;
	__GETWRN 16,17,0
_0x165:
	CALL SUBOPT_0x64
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x166
	CALL SUBOPT_0x66
	CALL SUBOPT_0x29
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     537 
;     538          for (i=1; i<=l[u]; i++)
	__ADDWRN 16,17,1
	RJMP _0x165
_0x166:
	__GETWRN 16,17,1
_0x168:
	CALL SUBOPT_0x64
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x169
;     539            reg[i] = elp[u][i] ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,6
	CALL SUBOPT_0x29
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     540          count = 0 ;
	__ADDWRN 16,17,1
	RJMP _0x168
_0x169:
	__CLRW1SX 66
;     541          for (i=1; i<=nn; i++)
	__GETWRN 16,17,1
_0x16B:
	__CPWRR 7,8,16,17
	BRGE PC+3
	JMP _0x16C
;     542           {  q = 1 ;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 226
;     543              for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x16E:
	CALL SUBOPT_0x64
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x16F
;     544               if (reg[j]!=-1)
	CALL SUBOPT_0x35
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x170
;     545                 { reg[j] = (reg[j]+j)%nn ;
	CALL SUBOPT_0x36
	CALL SUBOPT_0x35
	CALL SUBOPT_0x59
;     546                   q ^= alpha_to[reg[j]] ;
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	__GETW2SX 226
	EOR  R30,R26
	EOR  R31,R27
	__PUTW1SX 226
;     547                 } ;
_0x170:
	__ADDWRN 18,19,1
	RJMP _0x16E
_0x16F:
;     548              if (!q)        /* store root and error location number indices */
	__GETW1SX 226
	SBIW R30,0
	BRNE _0x171
;     549               { root[count] = i;
	__GETW1SX 66
	MOVW R26,R28
	ADIW R26,58
	CALL SUBOPT_0x38
;     550                 loc[count] = nn-i ;
	__GETW1SX 66
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x5A
;     551                 count++ ;
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	CALL SUBOPT_0x70
;     552               };
_0x171:
;     553           } ;
	__ADDWRN 16,17,1
	RJMP _0x16B
_0x16C:
;     554          if (count==l[u])    /* no. roots = degree of elp hence <= tt errors */
	CALL SUBOPT_0x64
	__GETW2SX 66
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x172
;     555           {
;     556            for (i=1; i<=l[u]; i++)        /* Z[0] = 1 always - do not need */
	__GETWRN 16,17,1
_0x174:
	CALL SUBOPT_0x64
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0x175
;     557             { if ((s[i]!=-1) && (elp[u][i]!=-1))
	CALL SUBOPT_0x61
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x177
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x178
_0x177:
	RJMP _0x176
_0x178:
;     558                  z[i] = alpha_to[s[i]] ^ alpha_to[elp[u][i]] ;
	CALL SUBOPT_0x71
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x61
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x25
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	EOR  R30,R22
	EOR  R31,R23
	POP  R26
	POP  R27
	RJMP _0x3B3
;     559               else if ((s[i]!=-1) && (elp[u][i]==-1))
_0x176:
	CALL SUBOPT_0x61
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x17B
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x17C
_0x17B:
	RJMP _0x17A
_0x17C:
;     560                       z[i] = alpha_to[s[i]] ;
	CALL SUBOPT_0x71
	CALL SUBOPT_0xD
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B3
;     561                    else if ((s[i]==-1) && (elp[u][i]!=-1))
_0x17A:
	CALL SUBOPT_0x61
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x17F
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x180
_0x17F:
	RJMP _0x17E
_0x180:
;     562                           z[i] = alpha_to[elp[u][i]] ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x29
	CALL SUBOPT_0x66
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R22
	RJMP _0x3B3
;     563                         else
_0x17E:
;     564                           z[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x32
_0x3B3:
	ST   X+,R30
	ST   X,R31
;     565               for (j=1; j<i; j++)
	__GETWRN 18,19,1
_0x183:
	__CPWRR 18,19,16,17
	BRGE _0x184
;     566                 if ((s[j]!=-1) && (elp[u][i-j]!=-1))
	CALL SUBOPT_0x72
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x186
	MOVW R30,R20
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x73
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x187
_0x186:
	RJMP _0x185
_0x187:
;     567                    z[i] ^= alpha_to[(elp[u][i-j] + s[j])%nn] ;
	CALL SUBOPT_0x71
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	MOVW R30,R20
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x73
	CALL SUBOPT_0x24
	CALL SUBOPT_0x72
	MOVW R26,R0
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     568               z[i] = index_of[z[i]] ;         /* put into index form */
_0x185:
	__ADDWRN 18,19,1
	RJMP _0x183
_0x184:
	CALL SUBOPT_0x71
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     569             } ;
	__ADDWRN 16,17,1
	RJMP _0x174
_0x175:
;     570 
;     571            for (i=0; i<nn; i++)
	__GETWRN 16,17,0
_0x189:
	__CPWRR 16,17,7,8
	BRGE _0x18A
;     572              { err[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,14
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     573                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x18B
;     574                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B4
;     575                else  recd[i] = 0 ;
_0x18B:
	CALL SUBOPT_0x3E
_0x3B4:
	ST   X+,R30
	ST   X,R31
;     576              }
	__ADDWRN 16,17,1
	RJMP _0x189
_0x18A:
;     577            for (i=0; i<l[u]; i++)    /* compute numerator of error term first */
	__GETWRN 16,17,0
_0x18E:
	CALL SUBOPT_0x64
	CP   R16,R30
	CPC  R17,R31
	BRLT PC+3
	JMP _0x18F
;     578             { err[loc[i]] = 1;       /* accounts for z[0] */
	CALL SUBOPT_0x17
	MOVW R26,R28
	ADIW R26,14
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x7
;     579               for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x191:
	CALL SUBOPT_0x64
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x192
;     580                 if (z[j]!=-1)
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x193
;     581                   err[loc[i]] ^= alpha_to[(z[j]+j*root[i])%nn] ;
	CALL SUBOPT_0x17
	MOVW R26,R28
	ADIW R26,14
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,44
	CALL SUBOPT_0x25
	CALL SUBOPT_0x74
	CALL SUBOPT_0x41
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     582               if (err[loc[i]]!=0)
_0x193:
	__ADDWRN 18,19,1
	RJMP _0x191
_0x192:
	CALL SUBOPT_0x17
	MOVW R26,R28
	ADIW R26,14
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE PC+3
	JMP _0x194
;     583                { err[loc[i]] = index_of[err[loc[i]]] ;
	CALL SUBOPT_0x17
	MOVW R26,R28
	ADIW R26,14
	LSL  R30
	ROL  R31
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,14
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     584                  q = 0 ;     /* form denominator of error term */
	__CLRW1SX 226
;     585                  for (j=0; j<l[u]; j++)
	__GETWRN 18,19,0
_0x196:
	CALL SUBOPT_0x64
	CP   R18,R30
	CPC  R19,R31
	BRGE _0x197
;     586                    if (j!=i)
	__CPWRR 16,17,18,19
	BREQ _0x198
;     587                      q += index_of[1^alpha_to[(loc[j]+root[i])%nn]] ;
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,52
	CALL SUBOPT_0x24
	CALL SUBOPT_0x74
	MOVW R26,R0
	CALL SUBOPT_0x47
	CALL SUBOPT_0x42
	__GETW2SX 226
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1SX 226
;     588                  q = q % nn ;
_0x198:
	__ADDWRN 18,19,1
	RJMP _0x196
_0x197:
	__GETW1R 7,8
	__GETW2SX 226
	CALL __MODW21
	__PUTW1SX 226
;     589                  err[loc[i]] = alpha_to[(err[loc[i]]-q+nn)%nn] ;
	CALL SUBOPT_0x17
	MOVW R26,R28
	ADIW R26,14
	CALL SUBOPT_0x29
	CALL SUBOPT_0x17
	MOVW R26,R28
	ADIW R26,14
	CALL SUBOPT_0x2
	__GETW2SX 226
	CALL SUBOPT_0x5F
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     590                  recd[loc[i]] ^= err[loc[i]] ;  /*recd[i] must be in polynomial form */
	CALL SUBOPT_0x17
	CALL SUBOPT_0x43
	MOVW R26,R28
	ADIW R26,14
	CALL SUBOPT_0x2
	CALL SUBOPT_0x44
;     591                }
;     592             }
_0x194:
	__ADDWRN 16,17,1
	RJMP _0x18E
_0x18F:
;     593           }
;     594          else {   /* no. roots != degree of elp => >tt errors and cannot solve */
	RJMP _0x199
_0x172:
;     595            chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     596            for (i=0; i<nn; i++)        /* could return error flag if desired */
	__GETWRN 16,17,0
_0x19B:
	__CPWRR 16,17,7,8
	BRGE _0x19C
;     597                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x19D
;     598                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B5
;     599                else  recd[i] = 0 ;     /* just output received codeword as is */
_0x19D:
	CALL SUBOPT_0x3E
_0x3B5:
	ST   X+,R30
	ST   X,R31
;     600           }     
	__ADDWRN 16,17,1
	RJMP _0x19B
_0x19C:
_0x199:
;     601        }
;     602      else {    /* elp has degree has degree >tt hence cannot solve */
	RJMP _0x19F
_0x163:
;     603        chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     604        for (i=0; i<nn; i++)       /* could return error flag if desired */
	__GETWRN 16,17,0
_0x1A1:
	__CPWRR 16,17,7,8
	BRGE _0x1A2
;     605           if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1A3
;     606             recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B6
;     607           else  recd[i] = 0 ;     /* just output received codeword as is */
_0x1A3:
	CALL SUBOPT_0x3E
_0x3B6:
	ST   X+,R30
	ST   X,R31
;     608       }   
	__ADDWRN 16,17,1
	RJMP _0x1A1
_0x1A2:
_0x19F:
;     609     }
;     610    else       /* no non-zero syndromes => no errors: output received codeword */
	RJMP _0x1A5
_0x134:
;     611     for (i=0; i<nn; i++)
	__GETWRN 16,17,0
_0x1A7:
	__CPWRR 16,17,7,8
	BRGE _0x1A8
;     612        if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1A9
;     613          recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B7
;     614        else  recd[i] = 0 ;
_0x1A9:
	CALL SUBOPT_0x3E
_0x3B7:
	ST   X+,R30
	ST   X,R31
;     615  }
	__ADDWRN 16,17,1
	RJMP _0x1A7
_0x1A8:
_0x1A5:
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,39
	RET
;     616  
;     617 void decode_rs3() {
_decode_rs3:
;     618    int i,j,u,q ;
;     619    int elp[15-7+2][15-7], d[15-7+2], l[15-7+2], u_lu[15-7+2], s[15-7+1] ;
;     620    int count=0, syn_error=0, root[4], loc[4], z[4+1], err[15], reg[4+1] ;
;     621 
;     622    for (i=1; i<=nn-kk; i++)
	SBIW R28,54
	SUBI R29,1
	LDI  R24,4
	LDI  R26,LOW(66)
	LDI  R27,HIGH(66)
	LDI  R30,LOW(_0x1AB*2)
	LDI  R31,HIGH(_0x1AB*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	u -> R20,R21
;	q -> Y+314
;	elp -> Y+154
;	d -> Y+134
;	l -> Y+114
;	u_lu -> Y+94
;	s -> Y+76
;	count -> Y+74
;	syn_error -> Y+72
;	root -> Y+64
;	loc -> Y+56
;	z -> Y+46
;	err -> Y+16
;	reg -> Y+6
	__GETWRN 16,17,1
_0x1AD:
	CALL SUBOPT_0x45
	BRGE PC+3
	JMP _0x1AE
;     623     { s[i] = 0 ;
	CALL SUBOPT_0x75
	CALL SUBOPT_0x14
;     624       for (j=0; j<nn; j++)
	__GETWRN 18,19,0
_0x1B0:
	__CPWRR 18,19,7,8
	BRGE _0x1B1
;     625         if (recd[j]!=-1)
	CALL SUBOPT_0x15
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1B2
;     626           s[i] ^= alpha_to[(recd[j]+i*j)%nn] ;      /* recd[j] in index form */
	CALL SUBOPT_0x75
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x16
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     627       if (s[i]!=0)  syn_error=1 ;        /* set flag if non-zero syndrome => error */
_0x1B2:
	__ADDWRN 18,19,1
	RJMP _0x1B0
_0x1B1:
	CALL SUBOPT_0x76
	SBIW R30,0
	BREQ _0x1B3
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 72
;     628       s[i] = index_of[s[i]] ;
_0x1B3:
	CALL SUBOPT_0x75
	CALL SUBOPT_0xD
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     629     } ;
	__ADDWRN 16,17,1
	RJMP _0x1AD
_0x1AE:
;     630 
;     631    if (syn_error)       /* if errors, try and correct */
	__GETW1SX 72
	SBIW R30,0
	BRNE PC+3
	JMP _0x1B4
;     632     {
;     633       d[0] = 0 ;           /* index form */
	__CLRW1SX 134
;     634       d[1] = s[1] ;        /* index form */
	MOVW R30,R28
	SUBI R30,LOW(-(134))
	SBCI R31,HIGH(-(134))
	ADIW R30,2
	__GETW2SX 78
	STD  Z+0,R26
	STD  Z+1,R27
;     635       elp[0][0] = 0 ;      /* index form */
	__CLRW1SX 154
;     636       elp[1][0] = 1 ;      /* polynomial form */
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 170
;     637       for (i=1; i<nn-kk; i++)
	__GETWRN 16,17,1
_0x1B6:
	CALL SUBOPT_0x49
	BRGE _0x1B7
;     638         { elp[0][i] = -1 ;   /* index form */
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	CALL SUBOPT_0x4A
;     639           elp[1][i] = 0 ;   /* polynomial form */
	MOVW R30,R28
	SUBI R30,LOW(-(154))
	SBCI R31,HIGH(-(154))
	ADIW R30,16
	CALL SUBOPT_0x1A
;     640         }
	__ADDWRN 16,17,1
	RJMP _0x1B6
_0x1B7:
;     641       l[0] = 0 ;
	__CLRW1SX 114
;     642       l[1] = 0 ;
	__CLRW1SX 116
;     643       u_lu[0] = -1 ;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	__PUTW1SX 94
;     644       u_lu[1] = 0 ;
	__CLRW1SX 96
;     645       u = 0 ;
	__GETWRN 20,21,0
;     646 
;     647       do
_0x1B9:
;     648       {
;     649         u++ ;
	__ADDWRN 20,21,1
;     650         if (d[u]==-1)
	CALL SUBOPT_0x77
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x1BB
;     651           { l[u+1] = l[u] ;
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x62
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     652             for (i=0; i<=l[u]; i++)
	__GETWRN 16,17,0
_0x1BD:
	CALL SUBOPT_0x62
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x1BE
;     653              {  elp[u+1][i] = elp[u][i] ;
	CALL SUBOPT_0x78
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x79
	CALL SUBOPT_0x20
;     654                 elp[u][i] = index_of[elp[u][i]] ;
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x79
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     655              }
	__ADDWRN 16,17,1
	RJMP _0x1BD
_0x1BE:
;     656           }
;     657         else
	RJMP _0x1BF
_0x1BB:
;     658           { q = u-1 ;
	MOVW R30,R20
	SBIW R30,1
	__PUTW1SX 314
;     659             while ((d[q]==-1) && (q>0)) q-- ;
_0x1C0:
	CALL SUBOPT_0x7B
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x1C3
	__GETW2SX 314
	CALL __CPW02
	BRLT _0x1C4
_0x1C3:
	RJMP _0x1C2
_0x1C4:
	MOVW R26,R28
	SUBI R26,LOW(-(314))
	SBCI R27,HIGH(-(314))
	CALL SUBOPT_0x23
;     660             if (q>0)
	RJMP _0x1C0
_0x1C2:
	__GETW2SX 314
	CALL __CPW02
	BRGE _0x1C5
;     661              { j=q ;
	__GETWRSX 18,19,314
;     662                do
_0x1C7:
;     663                { j-- ;
	__SUBWRN 18,19,1
;     664                  if ((d[j]!=-1) && (u_lu[q]<u_lu[j]))
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(134))
	SBCI R27,HIGH(-(134))
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1CA
	__GETW1SX 314
	MOVW R26,R28
	SUBI R26,LOW(-(94))
	SBCI R27,HIGH(-(94))
	CALL SUBOPT_0x24
	CALL SUBOPT_0x51
	CP   R0,R30
	CPC  R1,R31
	BRLT _0x1CB
_0x1CA:
	RJMP _0x1C9
_0x1CB:
;     665                    q = j ;
	__PUTWSRX 18,19,314
;     666                }while (j>0) ;
_0x1C9:
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRLT _0x1C7
;     667              } ;
_0x1C5:
;     668 
;     669             if (l[u]>l[q]+u-q)  l[u+1] = l[u] ;
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(114))
	SBCI R27,HIGH(-(114))
	CALL SUBOPT_0x25
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x7D
	CP   R30,R22
	CPC  R31,R23
	BRGE _0x1CC
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x62
	MOVW R26,R0
	RJMP _0x3B8
;     670             else  l[u+1] = l[q]+u-q ;
_0x1CC:
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x29
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x7D
	MOVW R26,R22
_0x3B8:
	ST   X+,R30
	ST   X,R31
;     671 
;     672             for (i=0; i<nn-kk; i++)    elp[u+1][i] = 0 ;
	__GETWRN 16,17,0
_0x1CF:
	CALL SUBOPT_0x49
	BRGE _0x1D0
	CALL SUBOPT_0x78
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     673             for (i=0; i<=l[q]; i++)
	__ADDWRN 16,17,1
	RJMP _0x1CF
_0x1D0:
	__GETWRN 16,17,0
_0x1D2:
	CALL SUBOPT_0x7C
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0x1D3
;     674               if (elp[q][i]!=-1)
	__GETW1SX 314
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1D4
;     675                 elp[u+1][i+u-q] = alpha_to[(d[u]+nn-d[q]+elp[q][i])%nn] ;
	MOVW R30,R20
	ADIW R30,1
	CALL __LSLW4
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	CALL SUBOPT_0x2B
	__GETW2SX 314
	CALL SUBOPT_0x2C
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x77
	ADD  R30,R7
	ADC  R31,R8
	MOVW R22,R30
	CALL SUBOPT_0x7B
	__SUBWRR 22,23,30,31
	__GETW1SX 314
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x2
	MOVW R26,R22
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     676             for (i=0; i<=l[u]; i++)
_0x1D4:
	__ADDWRN 16,17,1
	RJMP _0x1D2
_0x1D3:
	__GETWRN 16,17,0
_0x1D6:
	CALL SUBOPT_0x62
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x1D7
;     677               { elp[u+1][i] ^= elp[u][i] ;
	CALL SUBOPT_0x78
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LD   R0,Z
	LDD  R1,Z+1
	CALL SUBOPT_0x79
	EOR  R30,R0
	EOR  R31,R1
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     678                 elp[u][i] = index_of[elp[u][i]] ;  /*convert old elp value to index*/
	MOVW R30,R20
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x79
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     679               }
	__ADDWRN 16,17,1
	RJMP _0x1D6
_0x1D7:
;     680           }
_0x1BF:
;     681         u_lu[u+1] = u-l[u+1] ;
	CALL SUBOPT_0x56
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2E
;     682 
;     683         if (u<nn-kk)    /* no discrepancy computed on last iteration */
	CALL SUBOPT_0x54
	BRLT PC+3
	JMP _0x1D8
;     684           {
;     685             if (s[u+1]!=-1)
	CALL SUBOPT_0x7E
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1D9
;     686                    d[u+1] = alpha_to[s[u+1]] ;
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x7E
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3B9
;     687             else
_0x1D9:
;     688               d[u+1] = 0 ;
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x32
_0x3B9:
	ST   X+,R30
	ST   X,R31
;     689             for (i=1; i<=l[u+1]; i++)
	__GETWRN 16,17,1
_0x1DC:
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x1DD
;     690               if ((s[u+1-i]!=-1) && (elp[u+1][i]!=0))
	CALL SUBOPT_0x80
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1DF
	CALL SUBOPT_0x78
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE _0x1E0
_0x1DF:
	RJMP _0x1DE
_0x1E0:
;     691                 d[u+1] ^= alpha_to[(s[u+1-i]+index_of[elp[u+1][i]])%nn] ;
	CALL SUBOPT_0x7F
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x80
	CALL SUBOPT_0x24
	CALL SUBOPT_0x78
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     692             d[u+1] = index_of[d[u+1]] ;    /* put d[u+1] into index form */
_0x1DE:
	__ADDWRN 16,17,1
	RJMP _0x1DC
_0x1DD:
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     693           }
;     694       } while ((u<nn-kk) && (l[u+1]<=tt)) ;
_0x1D8:
	CALL SUBOPT_0x54
	BRGE _0x1E1
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x2
	CP   R13,R30
	CPC  R14,R31
	BRGE _0x1E2
_0x1E1:
	RJMP _0x1BA
_0x1E2:
	RJMP _0x1B9
_0x1BA:
;     695 
;     696       u++ ;
	__ADDWRN 20,21,1
;     697       if (l[u]<=tt)         /* can correct error */
	CALL SUBOPT_0x62
	CP   R13,R30
	CPC  R14,R31
	BRGE PC+3
	JMP _0x1E3
;     698        {
;     699          for (i=0; i<=l[u]; i++)   elp[u][i] = index_of[elp[u][i]] ;
	__GETWRN 16,17,0
_0x1E5:
	CALL SUBOPT_0x62
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x1E6
	MOVW R30,R20
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x79
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     700 
;     701          for (i=1; i<=l[u]; i++)
	__ADDWRN 16,17,1
	RJMP _0x1E5
_0x1E6:
	__GETWRN 16,17,1
_0x1E8:
	CALL SUBOPT_0x62
	CP   R30,R16
	CPC  R31,R17
	BRLT _0x1E9
;     702            reg[i] = elp[u][i] ;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x79
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     703          count = 0 ;
	__ADDWRN 16,17,1
	RJMP _0x1E8
_0x1E9:
	__CLRW1SX 74
;     704          for (i=1; i<=nn; i++)
	__GETWRN 16,17,1
_0x1EB:
	__CPWRR 7,8,16,17
	BRGE PC+3
	JMP _0x1EC
;     705           {  q = 1 ;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1SX 314
;     706              for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x1EE:
	CALL SUBOPT_0x62
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x1EF
;     707               if (reg[j]!=-1)
	CALL SUBOPT_0x35
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1F0
;     708                 { reg[j] = (reg[j]+j)%nn ;
	CALL SUBOPT_0x36
	CALL SUBOPT_0x35
	CALL SUBOPT_0x59
;     709                   q ^= alpha_to[reg[j]] ;
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	__GETW2SX 314
	EOR  R30,R26
	EOR  R31,R27
	__PUTW1SX 314
;     710                 } ;
_0x1F0:
	__ADDWRN 18,19,1
	RJMP _0x1EE
_0x1EF:
;     711              if (!q)        /* store root and error location number indices */
	__GETW1SX 314
	SBIW R30,0
	BRNE _0x1F1
;     712               { root[count] = i;
	__GETW1SX 74
	MOVW R26,R28
	SUBI R26,LOW(-(64))
	SBCI R27,HIGH(-(64))
	CALL SUBOPT_0x38
;     713                 loc[count] = nn-i ;
	__GETW1SX 74
	MOVW R26,R28
	ADIW R26,56
	CALL SUBOPT_0x5A
;     714                 count++ ;
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	CALL SUBOPT_0x70
;     715               };
_0x1F1:
;     716           } ;
	__ADDWRN 16,17,1
	RJMP _0x1EB
_0x1EC:
;     717          if (count==l[u])    /* no. roots = degree of elp hence <= tt errors */
	CALL SUBOPT_0x62
	__GETW2SX 74
	CP   R30,R26
	CPC  R31,R27
	BREQ PC+3
	JMP _0x1F2
;     718           {
;     719            for (i=1; i<=l[u]; i++)        /* Z[0] = 1 always - do not need */
	__GETWRN 16,17,1
_0x1F4:
	CALL SUBOPT_0x62
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0x1F5
;     720             { if ((s[i]!=-1) && (elp[u][i]!=-1))
	CALL SUBOPT_0x76
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1F7
	CALL SUBOPT_0x79
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x1F8
_0x1F7:
	RJMP _0x1F6
_0x1F8:
;     721                  z[i] = alpha_to[s[i]] ^ alpha_to[elp[u][i]] ;
	CALL SUBOPT_0x81
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x76
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x24
	CALL SUBOPT_0x79
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	EOR  R30,R0
	EOR  R31,R1
	POP  R26
	POP  R27
	RJMP _0x3BA
;     722               else if ((s[i]!=-1) && (elp[u][i]==-1))
_0x1F6:
	CALL SUBOPT_0x76
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1FB
	CALL SUBOPT_0x79
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x1FC
_0x1FB:
	RJMP _0x1FA
_0x1FC:
;     723                       z[i] = alpha_to[s[i]] ;
	CALL SUBOPT_0x81
	CALL SUBOPT_0xD
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3BA
;     724                    else if ((s[i]==-1) && (elp[u][i]!=-1))
_0x1FA:
	CALL SUBOPT_0x76
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x1FF
	CALL SUBOPT_0x79
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x200
_0x1FF:
	RJMP _0x1FE
_0x200:
;     725                           z[i] = alpha_to[elp[u][i]] ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,46
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x79
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3BA
;     726                         else
_0x1FE:
;     727                           z[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,46
	CALL SUBOPT_0x32
_0x3BA:
	ST   X+,R30
	ST   X,R31
;     728               for (j=1; j<i; j++)
	__GETWRN 18,19,1
_0x203:
	__CPWRR 18,19,16,17
	BRGE _0x204
;     729                 if ((s[j]!=-1) && (elp[u][i-j]!=-1))
	CALL SUBOPT_0x82
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x206
	CALL SUBOPT_0x83
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x207
_0x206:
	RJMP _0x205
_0x207:
;     730                    z[i] ^= alpha_to[(elp[u][i-j] + s[j])%nn] ;
	CALL SUBOPT_0x81
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x83
	CALL SUBOPT_0x24
	CALL SUBOPT_0x82
	MOVW R26,R0
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     731               z[i] = index_of[z[i]] ;         /* put into index form */
_0x205:
	__ADDWRN 18,19,1
	RJMP _0x203
_0x204:
	CALL SUBOPT_0x81
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,46
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     732             } ;
	__ADDWRN 16,17,1
	RJMP _0x1F4
_0x1F5:
;     733 
;     734            for (i=0; i<nn; i++)
	__GETWRN 16,17,0
_0x209:
	__CPWRR 16,17,7,8
	BRGE _0x20A
;     735              { err[i] = 0 ;
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;     736                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x20B
;     737                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3BB
;     738                else  recd[i] = 0 ;
_0x20B:
	CALL SUBOPT_0x3E
_0x3BB:
	ST   X+,R30
	ST   X,R31
;     739              }
	__ADDWRN 16,17,1
	RJMP _0x209
_0x20A:
;     740            for (i=0; i<l[u]; i++)    /* compute numerator of error term first */
	__GETWRN 16,17,0
_0x20E:
	CALL SUBOPT_0x62
	CP   R16,R30
	CPC  R17,R31
	BRLT PC+3
	JMP _0x20F
;     741             { err[loc[i]] = 1;       /* accounts for z[0] */
	CALL SUBOPT_0x84
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x7
;     742               for (j=1; j<=l[u]; j++)
	__GETWRN 18,19,1
_0x211:
	CALL SUBOPT_0x62
	CP   R30,R18
	CPC  R31,R19
	BRLT _0x212
;     743                 if (z[j]!=-1)
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,46
	CALL SUBOPT_0x2
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x213
;     744                   err[loc[i]] ^= alpha_to[(z[j]+j*root[i])%nn] ;
	CALL SUBOPT_0x84
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETW1P
	PUSH R31
	PUSH R30
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,46
	CALL SUBOPT_0x25
	CALL SUBOPT_0x85
	CALL SUBOPT_0x41
	CALL SUBOPT_0x47
	POP  R26
	POP  R27
	EOR  R30,R26
	EOR  R31,R27
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     745               if (err[loc[i]]!=0)
_0x213:
	__ADDWRN 18,19,1
	RJMP _0x211
_0x212:
	CALL SUBOPT_0x84
	MOVW R26,R28
	ADIW R26,16
	CALL SUBOPT_0x2
	SBIW R30,0
	BRNE PC+3
	JMP _0x214
;     746                { err[loc[i]] = index_of[err[loc[i]]] ;
	CALL SUBOPT_0x84
	MOVW R26,R28
	ADIW R26,16
	LSL  R30
	ROL  R31
	CALL SUBOPT_0xD
	MOVW R26,R28
	ADIW R26,56
	CALL SUBOPT_0x2
	MOVW R26,R28
	ADIW R26,16
	CALL SUBOPT_0x2
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;     747                  q = 0 ;     /* form denominator of error term */
	__CLRW1SX 314
;     748                  for (j=0; j<l[u]; j++)
	__GETWRN 18,19,0
_0x216:
	CALL SUBOPT_0x62
	CP   R18,R30
	CPC  R19,R31
	BRGE _0x217
;     749                    if (j!=i)
	__CPWRR 16,17,18,19
	BREQ _0x218
;     750                      q += index_of[1^alpha_to[(loc[j]+root[i])%nn]] ;
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,56
	CALL SUBOPT_0x24
	CALL SUBOPT_0x85
	MOVW R26,R0
	CALL SUBOPT_0x47
	CALL SUBOPT_0x42
	__GETW2SX 314
	ADD  R30,R26
	ADC  R31,R27
	__PUTW1SX 314
;     751                  q = q % nn ;
_0x218:
	__ADDWRN 18,19,1
	RJMP _0x216
_0x217:
	__GETW1R 7,8
	__GETW2SX 314
	CALL __MODW21
	__PUTW1SX 314
;     752                  err[loc[i]] = alpha_to[(err[loc[i]]-q+nn)%nn] ;
	CALL SUBOPT_0x84
	MOVW R26,R28
	ADIW R26,16
	CALL SUBOPT_0x29
	CALL SUBOPT_0x84
	MOVW R26,R28
	ADIW R26,16
	CALL SUBOPT_0x2
	__GETW2SX 314
	CALL SUBOPT_0x5F
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
;     753                  recd[loc[i]] ^= err[loc[i]] ;  /*recd[i] must be in polynomial form */
	CALL SUBOPT_0x84
	CALL SUBOPT_0x43
	MOVW R26,R28
	ADIW R26,16
	CALL SUBOPT_0x2
	CALL SUBOPT_0x44
;     754                }
;     755             }
_0x214:
	__ADDWRN 16,17,1
	RJMP _0x20E
_0x20F:
;     756           }
;     757          else {   /* no. roots != degree of elp => >tt errors and cannot solve */
	RJMP _0x219
_0x1F2:
;     758            chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     759            for (i=0; i<nn; i++)        /* could return error flag if desired */
	__GETWRN 16,17,0
_0x21B:
	__CPWRR 16,17,7,8
	BRGE _0x21C
;     760                if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x21D
;     761                  recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3BC
;     762                else  recd[i] = 0 ;     /* just output received codeword as is */
_0x21D:
	CALL SUBOPT_0x3E
_0x3BC:
	ST   X+,R30
	ST   X,R31
;     763          }      
	__ADDWRN 16,17,1
	RJMP _0x21B
_0x21C:
_0x219:
;     764        }
;     765      else  {       /* elp has degree has degree >tt hence cannot solve */
	RJMP _0x21F
_0x1E3:
;     766        chyba=1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     767        for (i=0; i<nn; i++)       /* could return error flag if desired */
	__GETWRN 16,17,0
_0x221:
	__CPWRR 16,17,7,8
	BRGE _0x222
;     768           if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x223
;     769             recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3BD
;     770           else  recd[i] = 0 ;     /* just output received codeword as is */
_0x223:
	CALL SUBOPT_0x3E
_0x3BD:
	ST   X+,R30
	ST   X,R31
;     771       }    
	__ADDWRN 16,17,1
	RJMP _0x221
_0x222:
_0x21F:
;     772     }
;     773    else       /* no non-zero syndromes => no errors: output received codeword */
	RJMP _0x225
_0x1B4:
;     774     for (i=0; i<nn; i++)
	__GETWRN 16,17,0
_0x227:
	__CPWRR 16,17,7,8
	BRGE _0x228
;     775        if (recd[i]!=-1)        /* convert recd[] to polynomial form */
	CALL SUBOPT_0x3C
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BREQ _0x229
;     776          recd[i] = alpha_to[recd[i]] ;
	CALL SUBOPT_0x3D
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	CALL SUBOPT_0x2
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	CALL SUBOPT_0x2
	MOVW R26,R0
	RJMP _0x3BE
;     777        else  recd[i] = 0 ;
_0x229:
	CALL SUBOPT_0x3E
_0x3BE:
	ST   X+,R30
	ST   X,R31
;     778  }
	__ADDWRN 16,17,1
	RJMP _0x227
_0x228:
_0x225:
	CALL __LOADLOCR6
	ADIW R28,60
	SUBI R29,-1
	RET
;     779  
;     780 void main(void)
;     781 {
_main:
;     782 // Declare your local variables here
;     783 int prijata_data_int[8];
;     784 int prijata_data_prokladane_int[64];
;     785 int usporadana_data_prokladane_int[66];
;     786 int data_odeslat_int[10];
;     787 int typ_kodu;
;     788 int krok=0;
;     789 int a=0;
;     790 int b=0;
;     791 int i=0;
;     792 int j=0;
;     793 int delka_prokladani=0;
;     794 unsigned char k;
;     795 
;     796 // Input/Output Ports initialization
;     797 // Port A initialization
;     798 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     799 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     800 PORTA=0x00;
	SBIW R28,49
	SUBI R29,1
	LDI  R24,8
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	LDI  R30,LOW(_0x22B*2)
	LDI  R31,HIGH(_0x22B*2)
	CALL __INITLOCB
;	prijata_data_int -> Y+289
;	prijata_data_prokladane_int -> Y+161
;	usporadana_data_prokladane_int -> Y+29
;	data_odeslat_int -> Y+9
;	typ_kodu -> R16,R17
;	krok -> R18,R19
;	a -> R20,R21
;	b -> Y+7
;	i -> Y+5
;	j -> Y+3
;	delka_prokladani -> Y+1
;	k -> Y+0
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     801 DDRA=0x00;
	OUT  0x1A,R30
;     802 
;     803 // Port B initialization
;     804 // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
;     805 // State7=T State6=T State5=P State4=P State3=1 State2=1 State1=0 State0=0 
;     806 PORTB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x18,R30
;     807 DDRB=0xFF;
	OUT  0x17,R30
;     808 
;     809 // Port C initialization
;     810 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     811 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     812 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     813 DDRC=0x00;
	OUT  0x14,R30
;     814 
;     815 // Port D initialization
;     816 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     817 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     818 PORTD=0x00;
	OUT  0x12,R30
;     819 DDRD=0x00;
	OUT  0x11,R30
;     820 
;     821 // Timer/Counter 0 initialization
;     822 // Clock source: System Clock
;     823 // Clock value: Timer 0 Stopped
;     824 // Mode: Normal top=FFh
;     825 // OC0 output: Disconnected
;     826 TCCR0=0x00;
	OUT  0x33,R30
;     827 TCNT0=0x00;
	OUT  0x32,R30
;     828 OCR0=0x00;
	OUT  0x3C,R30
;     829 
;     830 // Timer/Counter 1 initialization
;     831 // Clock source: System Clock
;     832 // Clock value: Timer 1 Stopped
;     833 // Mode: Normal top=FFFFh
;     834 // OC1A output: Discon.
;     835 // OC1B output: Discon.
;     836 // Noise Canceler: Off
;     837 // Input Capture on Falling Edge
;     838 // Timer 1 Overflow Interrupt: Off
;     839 // Input Capture Interrupt: Off
;     840 // Compare A Match Interrupt: Off
;     841 // Compare B Match Interrupt: Off
;     842 TCCR1A=0x00;
	OUT  0x2F,R30
;     843 TCCR1B=0x00;
	OUT  0x2E,R30
;     844 TCNT1H=0x00;
	OUT  0x2D,R30
;     845 TCNT1L=0x00;
	OUT  0x2C,R30
;     846 ICR1H=0x00;
	OUT  0x27,R30
;     847 ICR1L=0x00;
	OUT  0x26,R30
;     848 OCR1AH=0x00;
	OUT  0x2B,R30
;     849 OCR1AL=0x00;
	OUT  0x2A,R30
;     850 OCR1BH=0x00;
	OUT  0x29,R30
;     851 OCR1BL=0x00;
	OUT  0x28,R30
;     852 
;     853 // Timer/Counter 2 initialization
;     854 // Clock source: System Clock
;     855 // Clock value: Timer 2 Stopped
;     856 // Mode: Normal top=FFh
;     857 // OC2 output: Disconnected
;     858 ASSR=0x00;
	OUT  0x22,R30
;     859 TCCR2=0x00;
	OUT  0x25,R30
;     860 TCNT2=0x00;
	OUT  0x24,R30
;     861 OCR2=0x00;
	OUT  0x23,R30
;     862 
;     863 // External Interrupt(s) initialization
;     864 // INT0: Off
;     865 // INT1: Off
;     866 // INT2: Off
;     867 MCUCR=0x00;
	OUT  0x35,R30
;     868 MCUCSR=0x00;
	OUT  0x34,R30
;     869 
;     870 // Timer(s)/Counter(s) Interrupt(s) initialization
;     871 TIMSK=0x00;
	OUT  0x39,R30
;     872 
;     873 // USART initialization
;     874 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     875 // USART Receiver: On
;     876 // USART Transmitter: On
;     877 // USART Mode: Asynchronous
;     878 // USART Baud rate: 115200
;     879 UCSRA=0x00;
	OUT  0xB,R30
;     880 UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
;     881 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     882 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     883 UBRRL=0x01;
	LDI  R30,LOW(1)
	OUT  0x9,R30
;     884 
;     885 // Analog Comparator initialization
;     886 // Analog Comparator: Off
;     887 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     888 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     889 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     890 
;     891 //putchar(85);
;     892 //PORTB.0=0;
;     893 //PORTB.1=0;
;     894 //PORTB.2=0;
;     895 //PORTB.3=0;
;     896 
;     897 while (1) {
_0x22C:
;     898   while ( (UCSRA & 0x80)&&(krok==0) ) {
_0x22F:
	SBIS 0xB,7
	RJMP _0x232
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BREQ _0x233
_0x232:
	RJMP _0x231
_0x233:
;     899     while ( krok<30 ) {
_0x234:
	__CPWRN 18,19,30
	BRLT PC+3
	JMP _0x236
;     900       k=getchar();
	CALL _getchar
	ST   Y,R30
;     901       if ( krok==22 ) { //prokladani
	LDI  R30,LOW(22)
	LDI  R31,HIGH(22)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x237
;     902         prijata_data_prokladane_int[i]=k;
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	MOVW R26,R28
	SUBI R26,LOW(-(161))
	SBCI R27,HIGH(-(161))
	CALL SUBOPT_0x86
;     903         i++;
;     904         if ( i==64 ) { krok=32; i=0; k=0; typ_zpravy=64; /*PORTB.0=1;*/ };
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE _0x238
	__GETWRN 18,19,32
	CALL SUBOPT_0x87
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	__PUTW1R 5,6
_0x238:
;     905       };
_0x237:
;     906       if ( krok==21) { // bez prokladani
	LDI  R30,LOW(21)
	LDI  R31,HIGH(21)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x239
;     907         prijata_data_int[i]=k;
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	MOVW R26,R28
	SUBI R26,LOW(-(289))
	SBCI R27,HIGH(-(289))
	CALL SUBOPT_0x86
;     908         i++;
;     909         if ( i==8 ) { krok=31; i=0; k=0;   };
	SBIW R26,8
	BRNE _0x23A
	__GETWRN 18,19,31
	CALL SUBOPT_0x87
_0x23A:
;     910       };
_0x239:
;     911       if ( krok==1 ) {  // test jaky kod bude pouzit a jestli je pouzito prokladani
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x23B
;     912         if ( k>7 ) { //prokladani
	LD   R26,Y
	CPI  R26,LOW(0x8)
	BRLO _0x23C
;     913           if (k>=32) { a=4;   k=k-32; };
	CPI  R26,LOW(0x20)
	BRLO _0x23D
	__GETWRN 20,21,4
	LD   R30,Y
	SUBI R30,LOW(32)
	ST   Y,R30
_0x23D:
;     914           if (k>=16) { a=a+2; k=k-16; };
	LD   R26,Y
	CPI  R26,LOW(0x10)
	BRLO _0x23E
	__ADDWRN 20,21,2
	LD   R30,Y
	SUBI R30,LOW(16)
	ST   Y,R30
_0x23E:
;     915           if (k>=8 ) { a=a+1; k=k-8;  };
	LD   R26,Y
	CPI  R26,LOW(0x8)
	BRLO _0x23F
	__ADDWRN 20,21,1
	LD   R30,Y
	SUBI R30,LOW(8)
	ST   Y,R30
_0x23F:
;     916           //if (k>=4 ) { a++;   k=k-4;  };
;     917           delka_prokladani=a;  typ_kodu=k;  krok=22;  a=0; k=0; i=0; }
	__PUTWSR 20,21,1
	LDD  R16,Y+0
	CLR  R17
	__GETWRN 18,19,22
	__GETWRN 20,21,0
	LDI  R30,LOW(0)
	ST   Y,R30
	RJMP _0x3BF
;     918         else { // bez prokladani
_0x23C:
;     919           typ_kodu=k-4  ;  krok=21; i=0; };
	LD   R30,Y
	SUBI R30,LOW(4)
	MOV  R16,R30
	CLR  R17
	__GETWRN 18,19,21
_0x3BF:
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
;     920         i=0;  
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
;     921       };
_0x23B:
;     922       //prijeti SYN
;     923       if ( (k==85)&(krok==0) ) {
	LD   R26,Y
	LDI  R30,LOW(85)
	CALL __EQB12
	MOV  R0,R30
	MOVW R26,R18
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EQW12
	AND  R30,R0
	BREQ _0x241
;     924         typ_kodu=0;
	__GETWRN 16,17,0
;     925         krok=1;
	__GETWRN 18,19,1
;     926         a=0;
	__GETWRN 20,21,0
;     927       };
_0x241:
;     928     };  
	RJMP _0x234
_0x236:
;     929   }; // konec prvniho while - prijmani znaku
	RJMP _0x22F
_0x231:
;     930   while ( krok==31 ) { // ------ dekodovani bez prokladani -------------------------------------------
_0x242:
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	CP   R30,R18
	CPC  R31,R19
	BREQ PC+3
	JMP _0x244
;     931     switch (typ_kodu) {
	MOVW R30,R16
;     932       case 0:
	SBIW R30,0
	BREQ PC+3
	JMP _0x248
;     933         if (prijata_data_int[1]!=64) {
	__GETW2SX 291
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BREQ _0x249
;     934           prijata_data_int[0]=0;
	__CLRW1SX 289
;     935         }  
;     936         tt=1; kk=13; a=0;
_0x249:
	CALL SUBOPT_0x88
	__GETWRN 20,21,0
;     937         for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x24B:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x24C
;     938           b=prijata_data_int[i];
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
;     939           if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x24D
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x24D:
;     940           if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x24E
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x24E:
;     941           if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x24F
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x24F:
;     942           if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x250
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x250:
;     943           recd[2*i]=a;
	CALL SUBOPT_0x8F
;     944           a=0;
	__GETWRN 20,21,0
;     945           recd[2*i+1]=b;
	CALL SUBOPT_0x90
;     946           b=0;
;     947         };
	CALL SUBOPT_0x91
	RJMP _0x24B
_0x24C:
;     948         for (i=4;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x252:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x253
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x252
_0x253:
;     949         recd[2]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,4
;     950         generate_gf();
	CALL SUBOPT_0x94
;     951         gen_poly0();
;     952         for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x255:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x256
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x255
_0x256:
;     953         chyba=0;
	CLR  R4
;     954         decode_rs0();
	CALL SUBOPT_0x96
;     955         if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x257
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C0
;     956         else { typ_zpravy=64; };
_0x257:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C0:
	__PUTW1R 5,6
;     957         for (i=1; i<13; i++) { data0[i] = recd[i+2]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x25A:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,13
	BRGE _0x25B
	CALL SUBOPT_0x97
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,4
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x25A
_0x25B:
;     958         data0[0]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _data0,R30
	STS  _data0+1,R31
;     959         krok=41;
	__GETWRN 18,19,41
;     960       break;
	RJMP _0x247
;     961       case 1:
_0x248:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x25C
;     962         //for (i=0;i<8;i++) { if (prijata_data_int[i]==235) { prijata_data_int[i]=0; };  };
;     963         if (prijata_data_int[2]!=64) {
	__GETW2SX 293
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BREQ _0x25D
;     964           if (prijata_data_int[2]>=128) {
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRLT _0x25E
;     965             prijata_data_int[0]=0; prijata_data_int[2]=prijata_data_int[2]-128;}
	__CLRW1SX 289
	MOVW R30,R28
	SUBI R30,LOW(-(289))
	SBCI R31,HIGH(-(289))
	ADIW R30,4
	MOVW R26,R30
	__GETW1SX 293
	SUBI R30,LOW(128)
	SBCI R31,HIGH(128)
	ST   X+,R30
	ST   X,R31
;     966           if (prijata_data_int[2]>=32) {
_0x25E:
	__GETW2SX 293
	SBIW R26,32
	BRLT _0x25F
;     967             prijata_data_int[1]=0;  }
	__CLRW1SX 291
;     968         }    
_0x25F:
;     969         tt=2; kk=11; a=0;
_0x25D:
	CALL SUBOPT_0x99
	__GETWRN 20,21,0
;     970         for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x261:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x262
;     971           b=prijata_data_int[i];
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
;     972           if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x263
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x263:
;     973           if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x264
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x264:
;     974           if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x265
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x265:
;     975           if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x266
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x266:
;     976           recd[2*i]=a;
	CALL SUBOPT_0x8F
;     977           a=0;
	__GETWRN 20,21,0
;     978           recd[2*i+1]=b;
	CALL SUBOPT_0x90
;     979           b=0;
;     980         };
	CALL SUBOPT_0x91
	RJMP _0x261
_0x262:
;     981         for (i=6;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x268:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x269
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x268
_0x269:
;     982         recd[4]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,8
;     983         generate_gf();
	CALL SUBOPT_0x94
;     984         gen_poly0();
;     985         for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x26B:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x26C
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x26B
_0x26C:
;     986         chyba=0;
	CALL SUBOPT_0x9A
;     987         decode_rs1();
;     988         if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x26D
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C1
;     989         else { typ_zpravy=64; };
_0x26D:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C1:
	__PUTW1R 5,6
;     990         for (i=1; i<11; i++) { data0[i] = recd[i+4]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x270:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,11
	BRGE _0x271
	CALL SUBOPT_0x97
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,8
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x270
_0x271:
;     991         data0[0]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _data0,R30
	STS  _data0+1,R31
;     992         krok=41;
	__GETWRN 18,19,41
;     993       break;
	RJMP _0x247
;     994       case 2:
_0x25C:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x272
;     995         //for (i=0;i<8;i++) { if (prijata_data_int[i]==235) { prijata_data_int[i]=0; };  };
;     996         if (prijata_data_int[3]!=64) {
	__GETW2SX 295
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BREQ _0x273
;     997           if (prijata_data_int[3]>=128) {
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRLT _0x274
;     998             prijata_data_int[0]=0; prijata_data_int[3]=prijata_data_int[3]-128;}
	__CLRW1SX 289
	CALL SUBOPT_0x9B
	SUBI R30,LOW(128)
	SBCI R31,HIGH(128)
	ST   X+,R30
	ST   X,R31
;     999           if (prijata_data_int[3]>=32) {
_0x274:
	__GETW2SX 295
	SBIW R26,32
	BRLT _0x275
;    1000             prijata_data_int[1]=0; prijata_data_int[3]=prijata_data_int[3]-32;}
	__CLRW1SX 291
	CALL SUBOPT_0x9B
	SBIW R30,32
	ST   X+,R30
	ST   X,R31
;    1001           if (prijata_data_int[3]>=8 ) {
_0x275:
	__GETW2SX 295
	SBIW R26,8
	BRLT _0x276
;    1002             prijata_data_int[2]=0;  }
	__CLRW1SX 293
;    1003         }    
_0x276:
;    1004         tt=3; kk=9; a=0;
_0x273:
	CALL SUBOPT_0x9C
	__GETWRN 20,21,0
;    1005         for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x278:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x279
;    1006           b=prijata_data_int[i];
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
;    1007           if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x27A
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x27A:
;    1008           if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x27B
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x27B:
;    1009           if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x27C
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x27C:
;    1010           if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x27D
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x27D:
;    1011           recd[2*i]=a;
	CALL SUBOPT_0x8F
;    1012           a=0;
	__GETWRN 20,21,0
;    1013           recd[2*i+1]=b;
	CALL SUBOPT_0x90
;    1014           b=0;
;    1015         };
	CALL SUBOPT_0x91
	RJMP _0x278
_0x279:
;    1016         for (i=8;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x27F:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x280
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x27F
_0x280:
;    1017         recd[6]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,12
;    1018         generate_gf();
	CALL SUBOPT_0x94
;    1019         gen_poly0();
;    1020         for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x282:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x283
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x282
_0x283:
;    1021         chyba=0;
	CALL SUBOPT_0x9D
;    1022         decode_rs2();
;    1023         if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x284
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C2
;    1024         else { typ_zpravy=64; };
_0x284:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C2:
	__PUTW1R 5,6
;    1025         for (i=1; i<9; i++) { data0[i] = recd[i+6]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x287:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,9
	BRGE _0x288
	CALL SUBOPT_0x97
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,12
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x287
_0x288:
;    1026         data0[0]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _data0,R30
	STS  _data0+1,R31
;    1027         krok=41;
	__GETWRN 18,19,41
;    1028       break;
	RJMP _0x247
;    1029       case 3:
_0x272:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x247
;    1030         //for (i=0;i<8;i++) { if (prijata_data_int[i]==235) { prijata_data_int[i]=0; };  };
;    1031         if (prijata_data_int[4]!=64) {
	__GETW2SX 297
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRNE PC+3
	JMP _0x28A
;    1032           if (prijata_data_int[4]>=128) {
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRLT _0x28B
;    1033             prijata_data_int[0]=0; prijata_data_int[4]=prijata_data_int[4]-128;}
	__CLRW1SX 289
	CALL SUBOPT_0x9E
	SUBI R30,LOW(128)
	SBCI R31,HIGH(128)
	ST   X+,R30
	ST   X,R31
;    1034           if (prijata_data_int[4]>=32) {
_0x28B:
	__GETW2SX 297
	SBIW R26,32
	BRLT _0x28C
;    1035             prijata_data_int[1]=0; prijata_data_int[4]=prijata_data_int[4]-32; }
	__CLRW1SX 291
	CALL SUBOPT_0x9E
	SBIW R30,32
	ST   X+,R30
	ST   X,R31
;    1036           if (prijata_data_int[4]>=8) {
_0x28C:
	__GETW2SX 297
	SBIW R26,8
	BRLT _0x28D
;    1037             prijata_data_int[2]=0; prijata_data_int[4]=prijata_data_int[4]-8;  }  
	__CLRW1SX 293
	CALL SUBOPT_0x9E
	SBIW R30,8
	ST   X+,R30
	ST   X,R31
;    1038           if (prijata_data_int[4]>=2 ) {
_0x28D:
	__GETW2SX 297
	SBIW R26,2
	BRLT _0x28E
;    1039             prijata_data_int[3]=0;  }
	__CLRW1SX 295
;    1040         }    
_0x28E:
;    1041         tt=4; kk=7; a=0;
_0x28A:
	CALL SUBOPT_0x9F
	__GETWRN 20,21,0
;    1042         for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x290:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x291
;    1043           b=prijata_data_int[i];
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
;    1044           if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x292
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x292:
;    1045           if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x293
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x293:
;    1046           if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x294
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x294:
;    1047           if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x295
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x295:
;    1048           recd[2*i]=a;
	CALL SUBOPT_0x8F
;    1049           a=0;
	__GETWRN 20,21,0
;    1050           recd[2*i+1]=b;
	CALL SUBOPT_0x90
;    1051           b=0;
;    1052         };
	CALL SUBOPT_0x91
	RJMP _0x290
_0x291:
;    1053         for (i=10;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x297:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x298
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x297
_0x298:
;    1054         recd[8]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,16
;    1055         generate_gf();
	CALL SUBOPT_0x94
;    1056         gen_poly0();
;    1057         for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x29A:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x29B
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x29A
_0x29B:
;    1058         chyba=0;
	CALL SUBOPT_0xA0
;    1059         decode_rs3();
;    1060         if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x29C
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C3
;    1061         else { typ_zpravy=64; };
_0x29C:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C3:
	__PUTW1R 5,6
;    1062         for (i=1; i<7; i++) { data0[i] = recd[i+8]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x29F:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,7
	BRGE _0x2A0
	CALL SUBOPT_0x97
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,16
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x29F
_0x2A0:
;    1063         data0[0]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _data0,R30
	STS  _data0+1,R31
;    1064         krok=41;
	__GETWRN 18,19,41
;    1065       break;
;    1066     };
_0x247:
;    1067     a=0; b=data0[1];
	__GETWRN 20,21,0
	__GETW1MN _data0,2
	CALL SUBOPT_0xA1
;    1068     if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x2A1
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x2A1:
;    1069     if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x2A2
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x2A2:
;    1070     if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x2A3
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x2A3:
;    1071     if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x2A4
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x2A4:
;    1072     b=data0[2];
	__GETW1MN _data0,4
	CALL SUBOPT_0xA1
;    1073     if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x2A5
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x2A5:
;    1074     if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x2A6
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x2A6:
;    1075     if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x2A7
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x2A7:
;    1076     if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x2A8
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x2A8:
;    1077     PORTB=a; a=0; b=0;
	MOVW R30,R20
	OUT  0x18,R30
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
;    1078   };
	RJMP _0x242
_0x244:
;    1079   while ( krok==32 ) { // --- dekodovani pri prokladani ---------------------------------------------
_0x2A9:
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CP   R30,R18
	CPC  R31,R19
	BREQ PC+3
	JMP _0x2AB
;    1080     //-- serazeni ----
;    1081     for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x2AD:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x2AE
;    1082       for (j=0;j<8;j++) {
	LDI  R30,0
	STD  Y+3,R30
	STD  Y+3+1,R30
_0x2B0:
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	SBIW R26,8
	BRGE _0x2B1
;    1083         usporadana_data_prokladane_int[i*8+j]=prijata_data_prokladane_int[j*8+i];
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	CALL __LSLW3
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R26,R28
	ADIW R26,29
	CALL SUBOPT_0x2D
	CALL SUBOPT_0xA5
	MOVW R26,R28
	SUBI R26,LOW(-(161))
	SBCI R27,HIGH(-(161))
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;    1084       };
	CALL SUBOPT_0xA6
	RJMP _0x2B0
_0x2B1:
;    1085     };
	CALL SUBOPT_0x91
	RJMP _0x2AD
_0x2AE:
;    1086     i=0; j=0; //PORTB.1=1;
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
	LDI  R30,0
	STD  Y+3,R30
	STD  Y+3+1,R30
;    1087     //-- dekodovani ----
;    1088     chyba=0;
	CLR  R4
;    1089     for (j=0;j<(delka_prokladani);j++) {
	LDI  R30,0
	STD  Y+3,R30
	STD  Y+3+1,R30
_0x2B3:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	CP   R26,R30
	CPC  R27,R31
	BRLT PC+3
	JMP _0x2B4
;    1090       switch (typ_kodu) {
	MOVW R30,R16
;    1091         case 0:
	SBIW R30,0
	BREQ PC+3
	JMP _0x2B8
;    1092           if (usporadana_data_prokladane_int[j*8+1]!=64) { // test jestli nejsou data nulova
	CALL SUBOPT_0xA7
	CALL SUBOPT_0x2
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BREQ _0x2B9
;    1093           usporadana_data_prokladane_int[0+j*8]=0;
	CALL SUBOPT_0xA8
;    1094           }  
;    1095           tt=1; kk=13; a=0;
_0x2B9:
	CALL SUBOPT_0x88
	__GETWRN 20,21,0
;    1096           for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x2BB:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x2BC
;    1097             b=usporadana_data_prokladane_int[j*8+i];
	CALL SUBOPT_0xA5
	MOVW R26,R28
	ADIW R26,29
	CALL SUBOPT_0x2
	CALL SUBOPT_0x8A
;    1098             if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x2BD
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x2BD:
;    1099             if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x2BE
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x2BE:
;    1100             if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x2BF
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x2BF:
;    1101             if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x2C0
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x2C0:
;    1102             recd[2*i]=a;
	CALL SUBOPT_0x8F
;    1103             a=0;
	__GETWRN 20,21,0
;    1104             recd[2*i+1]=b;
	CALL SUBOPT_0x90
;    1105             b=0;
;    1106           };
	CALL SUBOPT_0x91
	RJMP _0x2BB
_0x2BC:
;    1107           for (i=4;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x2C2:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x2C3
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x2C2
_0x2C3:
;    1108           recd[2]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,4
;    1109           generate_gf();
	CALL SUBOPT_0x94
;    1110           gen_poly0();
;    1111           for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x2C5:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x2C6
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x2C5
_0x2C6:
;    1112           decode_rs0();
	CALL SUBOPT_0x96
;    1113           if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x2C7
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C4
;    1114           else { typ_zpravy=64; };
_0x2C7:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C4:
	__PUTW1R 5,6
;    1115           for (i=1; i<13; i++) { data0_prokladane[i+13*j] = recd[i+2]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x2CA:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,13
	BRGE _0x2CB
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDI  R26,LOW(13)
	LDI  R27,HIGH(13)
	CALL SUBOPT_0xA9
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,4
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x2CA
_0x2CB:
;    1116           data0_prokladane[0+j*13]=0;
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	CALL SUBOPT_0xAA
	__ADDW2MN _data0_prokladane,0
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
;    1117           krok=42;
	__GETWRN 18,19,42
;    1118           PORTB=usporadana_data_prokladane_int[2];
	LDD  R30,Y+33
	LDD  R31,Y+33+1
	RJMP _0x3C5
;    1119         break;
;    1120         case 1:
_0x2B8:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2CC
;    1121           if (usporadana_data_prokladane_int[j*8+2]!=64) {
	CALL SUBOPT_0xAB
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BREQ _0x2CD
;    1122             if (usporadana_data_prokladane_int[j*8+2]>=128) {
	CALL SUBOPT_0xAB
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRLT _0x2CE
;    1123               usporadana_data_prokladane_int[j*8+0]=0; usporadana_data_prokladane_int[j*8+2]=usporadana_data_prokladane_int[j*8+2]-128;}
	CALL SUBOPT_0xA8
	CALL SUBOPT_0xAC
	CALL SUBOPT_0x2D
	CALL SUBOPT_0xAB
	CALL SUBOPT_0xAD
;    1124             if (usporadana_data_prokladane_int[j*8+2]>=32) {
_0x2CE:
	CALL SUBOPT_0xAB
	SBIW R30,32
	BRLT _0x2CF
;    1125               usporadana_data_prokladane_int[j*8+1]=0;  }
	CALL SUBOPT_0xA7
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;    1126           }    
_0x2CF:
;    1127           tt=2; kk=11; a=0;
_0x2CD:
	CALL SUBOPT_0x99
	__GETWRN 20,21,0
;    1128           for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x2D1:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x2D2
;    1129             b=usporadana_data_prokladane_int[j*8+i];
	CALL SUBOPT_0xA5
	MOVW R26,R28
	ADIW R26,29
	CALL SUBOPT_0x2
	CALL SUBOPT_0x8A
;    1130             if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x2D3
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x2D3:
;    1131             if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x2D4
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x2D4:
;    1132             if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x2D5
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x2D5:
;    1133             if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x2D6
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x2D6:
;    1134             recd[2*i]=a;
	CALL SUBOPT_0x8F
;    1135             a=0;
	__GETWRN 20,21,0
;    1136             recd[2*i+1]=b;
	CALL SUBOPT_0x90
;    1137             b=0;
;    1138           };
	CALL SUBOPT_0x91
	RJMP _0x2D1
_0x2D2:
;    1139           for (i=6;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x2D8:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x2D9
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x2D8
_0x2D9:
;    1140           recd[4]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,8
;    1141           generate_gf();
	CALL SUBOPT_0x94
;    1142           gen_poly0();
;    1143           for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x2DB:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x2DC
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x2DB
_0x2DC:
;    1144           chyba=0;
	CALL SUBOPT_0x9A
;    1145           decode_rs1();
;    1146           if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x2DD
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C6
;    1147           else { typ_zpravy=64; };
_0x2DD:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C6:
	__PUTW1R 5,6
;    1148           for (i=1; i<11; i++) { data0_prokladane[i+11*j] = recd[i+4]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x2E0:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,11
	BRGE _0x2E1
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDI  R26,LOW(11)
	LDI  R27,HIGH(11)
	CALL SUBOPT_0xA9
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,8
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x2E0
_0x2E1:
;    1149           data0_prokladane[0+j*11]=0;
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	CALL SUBOPT_0xAA
	__ADDW2MN _data0_prokladane,0
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
;    1150           krok=42;
	__GETWRN 18,19,42
;    1151           //PORTB=3;
;    1152           PORTB=usporadana_data_prokladane_int[3];
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	RJMP _0x3C5
;    1153         break;
;    1154         case 2:
_0x2CC:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2E2
;    1155           if (usporadana_data_prokladane_int[j*8+3]!=64) {
	CALL SUBOPT_0xAE
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BREQ _0x2E3
;    1156             if (usporadana_data_prokladane_int[j*8+3]>=128) {
	CALL SUBOPT_0xAE
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRLT _0x2E4
;    1157               usporadana_data_prokladane_int[j*8+0]=0; usporadana_data_prokladane_int[j*8+3]=usporadana_data_prokladane_int[j*8+3]-128;}
	CALL SUBOPT_0xA8
	CALL SUBOPT_0xAF
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xAD
;    1158             if (usporadana_data_prokladane_int[j*8+3]>=32) {
_0x2E4:
	CALL SUBOPT_0xAE
	SBIW R30,32
	BRLT _0x2E5
;    1159               usporadana_data_prokladane_int[j*8+1]=0; usporadana_data_prokladane_int[j*8+3]=usporadana_data_prokladane_int[j*8+3]-32;}
	CALL SUBOPT_0xA7
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
	CALL SUBOPT_0xAF
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xB0
;    1160             if (usporadana_data_prokladane_int[j*8+3]>=8 ) {
_0x2E5:
	CALL SUBOPT_0xAE
	SBIW R30,8
	BRLT _0x2E6
;    1161               usporadana_data_prokladane_int[j*8+2]=0;  }
	CALL SUBOPT_0xAC
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;    1162           }    
_0x2E6:
;    1163           tt=3; kk=9; a=0;
_0x2E3:
	CALL SUBOPT_0x9C
	__GETWRN 20,21,0
;    1164           for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x2E8:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x2E9
;    1165             b=usporadana_data_prokladane_int[j*8+i];
	CALL SUBOPT_0xA5
	MOVW R26,R28
	ADIW R26,29
	CALL SUBOPT_0x2
	CALL SUBOPT_0x8A
;    1166             if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x2EA
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x2EA:
;    1167             if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x2EB
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x2EB:
;    1168             if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x2EC
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x2EC:
;    1169             if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x2ED
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x2ED:
;    1170             recd[2*i]=a;
	CALL SUBOPT_0x8F
;    1171             a=0;
	__GETWRN 20,21,0
;    1172             recd[2*i+1]=b;
	CALL SUBOPT_0x90
;    1173             b=0;
;    1174           };
	CALL SUBOPT_0x91
	RJMP _0x2E8
_0x2E9:
;    1175           for (i=8;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x2EF:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x2F0
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x2EF
_0x2F0:
;    1176           recd[6]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,12
;    1177           generate_gf();
	CALL SUBOPT_0x94
;    1178           gen_poly0();
;    1179           for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x2F2:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x2F3
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x2F2
_0x2F3:
;    1180           chyba=0;
	CALL SUBOPT_0x9D
;    1181           decode_rs2();
;    1182           if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x2F4
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C7
;    1183           else { typ_zpravy=64; };
_0x2F4:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C7:
	__PUTW1R 5,6
;    1184           for (i=1; i<9; i++) { data0_prokladane[i+9*j] = recd[i+6]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x2F7:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,9
	BRGE _0x2F8
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	CALL SUBOPT_0xA9
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,12
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x2F7
_0x2F8:
;    1185           data0_prokladane[0+j*9]=0;
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	CALL SUBOPT_0xAA
	__ADDW2MN _data0_prokladane,0
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
;    1186           krok=42;
	__GETWRN 18,19,42
;    1187           //PORTB=5;
;    1188           PORTB=usporadana_data_prokladane_int[4];
	LDD  R30,Y+37
	LDD  R31,Y+37+1
	RJMP _0x3C5
;    1189         break;
;    1190         case 3:
_0x2E2:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2B7
;    1191           if (usporadana_data_prokladane_int[j*8+4]!=64) {
	CALL SUBOPT_0xB1
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE PC+3
	JMP _0x2FA
;    1192             if (usporadana_data_prokladane_int[j*8+4]>=128) {
	CALL SUBOPT_0xB1
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRLT _0x2FB
;    1193               usporadana_data_prokladane_int[j*8+0]=0; usporadana_data_prokladane_int[j*8+4]=usporadana_data_prokladane_int[j*8+4]-128;}
	CALL SUBOPT_0xA8
	CALL SUBOPT_0xB2
	CALL SUBOPT_0xB1
	CALL SUBOPT_0xAD
;    1194             if (usporadana_data_prokladane_int[j*8+4]>=32) {
_0x2FB:
	CALL SUBOPT_0xB1
	SBIW R30,32
	BRLT _0x2FC
;    1195               usporadana_data_prokladane_int[j*8+1]=0; usporadana_data_prokladane_int[j*8+4]=usporadana_data_prokladane_int[j*8+4]-32; }
	CALL SUBOPT_0xA7
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
	CALL SUBOPT_0xB2
	CALL SUBOPT_0xB1
	CALL SUBOPT_0xB0
;    1196             if (usporadana_data_prokladane_int[j*8+4]>=8) {
_0x2FC:
	CALL SUBOPT_0xB1
	SBIW R30,8
	BRLT _0x2FD
;    1197               usporadana_data_prokladane_int[j*8+2]=0; usporadana_data_prokladane_int[j*8+4]=usporadana_data_prokladane_int[j*8+4]-8;  }  
	CALL SUBOPT_0xAC
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
	CALL SUBOPT_0xB2
	CALL SUBOPT_0xB1
	SBIW R30,8
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
;    1198             if (usporadana_data_prokladane_int[j*8+4]>=2 ) {
_0x2FD:
	CALL SUBOPT_0xB1
	SBIW R30,2
	BRLT _0x2FE
;    1199               usporadana_data_prokladane_int[j*8+3]=0;  }
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,3
	MOVW R26,R28
	ADIW R26,29
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;    1200           }    
_0x2FE:
;    1201           tt=4; kk=7; a=0;
_0x2FA:
	CALL SUBOPT_0x9F
	__GETWRN 20,21,0
;    1202           for (i=0;i<8;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x300:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x301
;    1203             b=usporadana_data_prokladane_int[j*8+i];
	CALL SUBOPT_0xA5
	MOVW R26,R28
	ADIW R26,29
	CALL SUBOPT_0x2
	CALL SUBOPT_0x8A
;    1204             if ( b>=128 ) { a=8;   b=b-128; };
	BRLT _0x302
	__GETWRN 20,21,8
	CALL SUBOPT_0x8B
_0x302:
;    1205             if ( b>=64  ) { a=a+4; b=b-64;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x303
	__ADDWRN 20,21,4
	CALL SUBOPT_0x8C
_0x303:
;    1206             if ( b>=32  ) { a=a+2; b=b-32;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,32
	BRLT _0x304
	__ADDWRN 20,21,2
	CALL SUBOPT_0x8D
_0x304:
;    1207             if ( b>=16  ) { a++;   b=b-16;  };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,16
	BRLT _0x305
	__ADDWRN 20,21,1
	CALL SUBOPT_0x8E
_0x305:
;    1208             recd[2*i]=a;
	CALL SUBOPT_0x8F
;    1209             a=0;
	__GETWRN 20,21,0
;    1210             recd[2*i+1]=b;
	CALL SUBOPT_0x90
;    1211             b=0;
;    1212           };
	CALL SUBOPT_0x91
	RJMP _0x300
_0x301:
;    1213           for (i=10;i<16;i++) { recd[i-1]=recd[i]; };
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x307:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x308
	CALL SUBOPT_0x92
	CALL SUBOPT_0x93
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x307
_0x308:
;    1214           recd[8]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _recd,16
;    1215           generate_gf();
	CALL SUBOPT_0x94
;    1216           gen_poly0();
;    1217           for (i=0; i<15; i++) { recd[i] = index_of[recd[i]]; };
_0x30A:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,15
	BRGE _0x30B
	CALL SUBOPT_0x95
	CALL SUBOPT_0x93
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	CALL SUBOPT_0x2
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	CALL SUBOPT_0x91
	RJMP _0x30A
_0x30B:
;    1218           chyba=0;
	CALL SUBOPT_0xA0
;    1219           decode_rs3();
;    1220           if (chyba == 1) { typ_zpravy=192; }
	BRNE _0x30C
	LDI  R30,LOW(192)
	LDI  R31,HIGH(192)
	RJMP _0x3C8
;    1221           else { typ_zpravy=64; };
_0x30C:
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
_0x3C8:
	__PUTW1R 5,6
;    1222           for (i=1; i<7; i++) { data0_prokladane[i+7*j] = recd[i+8]; };
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+5,R30
	STD  Y+5+1,R31
_0x30F:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,7
	BRGE _0x310
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	LDI  R26,LOW(7)
	LDI  R27,HIGH(7)
	CALL SUBOPT_0xA9
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	LSL  R26
	ROL  R27
	__ADDW2MN _recd,16
	CALL SUBOPT_0x98
	CALL SUBOPT_0x91
	RJMP _0x30F
_0x310:
;    1223           data0_prokladane[j*7]=0;
	LDD  R26,Y+3
	LDD  R27,Y+3+1
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CALL __MULW12
	LDI  R26,LOW(_data0_prokladane)
	LDI  R27,HIGH(_data0_prokladane)
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
;    1224           krok=42;
	__GETWRN 18,19,42
;    1225           //PORTB=7;
;    1226           PORTB=usporadana_data_prokladane_int[5];
	LDD  R30,Y+39
	LDD  R31,Y+39+1
_0x3C5:
	OUT  0x18,R30
;    1227         break;
;    1228       };
_0x2B7:
;    1229     };
	CALL SUBOPT_0xA6
	RJMP _0x2B3
_0x2B4:
;    1230     i=0; j=0;
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
	LDI  R30,0
	STD  Y+3,R30
	STD  Y+3+1,R30
;    1231   };
	RJMP _0x2A9
_0x2AB:
;    1232   while ( krok==42 ) { // --- kodovani s prokladnanim -----------------------------------------------
_0x311:
	LDI  R30,LOW(42)
	LDI  R31,HIGH(42)
	CP   R30,R18
	CPC  R31,R19
	BREQ PC+3
	JMP _0x313
;    1233     a=0; b=data0_prokladane[1];
	__GETWRN 20,21,0
	__GETW1MN _data0_prokladane,2
	CALL SUBOPT_0xA1
;    1234     if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x314
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x314:
;    1235     if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x315
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x315:
;    1236     if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x316
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x316:
;    1237     if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x317
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x317:
;    1238     b=data0_prokladane[2];
	__GETW1MN _data0_prokladane,4
	CALL SUBOPT_0xA1
;    1239     if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x318
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x318:
;    1240     if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x319
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x319:
;    1241     if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x31A
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x31A:
;    1242     if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x31B
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x31B:
;    1243      a=0; b=0;
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
;    1244   // zadefinujeme libvolnou zpravu a data0 a odesleme ji jako ACK
;    1245   // dekodovana data jsou ulozena v data0_prokladane
;    1246   data0[0]=0; data0[1]=3; data0[2]=0; data0[3]=3; data0[4]=1; data0[5]=3; data0[6]=2; 
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _data0,R30
	STS  _data0+1,R31
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1MN _data0,2
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _data0,4
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1MN _data0,6
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1MN _data0,8
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1MN _data0,10
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1MN _data0,12
;    1247   data0[7]=3; data0[8]=3; data0[9]=3; data0[10]=4; data0[11]=3; data0[12]=5;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1MN _data0,14
	__PUTW1MN _data0,16
	__PUTW1MN _data0,18
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1MN _data0,20
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1MN _data0,22
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	__PUTW1MN _data0,24
;    1248   // pokracujeme normalne odeslanim ack
;    1249   krok=41; typ_kodu=0; tt=1; kk=13; a=0; i=0; j=0;
	__GETWRN 18,19,41
	__GETWRN 16,17,0
	CALL SUBOPT_0x88
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
	LDI  R30,0
	STD  Y+3,R30
	STD  Y+3+1,R30
;    1250   };
	RJMP _0x311
_0x313:
;    1251   while ( krok==41 ) { // --- kodovani bez prokladani -----------------------------------------------
_0x31C:
	LDI  R30,LOW(41)
	LDI  R31,HIGH(41)
	CP   R30,R18
	CPC  R31,R19
	BREQ PC+3
	JMP _0x31E
;    1252     //PORTB.3=1;
;    1253     switch (typ_kodu) {
	MOVW R30,R16
;    1254       case 0:
	SBIW R30,0
	BREQ PC+3
	JMP _0x322
;    1255         generate_gf();
	CALL SUBOPT_0xB3
;    1256         gen_poly0();
;    1257         encode_rs0();
;    1258         a=0; b=bb0[0];
	__GETWRN 20,21,0
	LDS  R30,_bb0
	LDS  R31,_bb0+1
	CALL SUBOPT_0xA1
;    1259          if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x323
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x323:
;    1260          if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x324
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x324:
;    1261          if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x325
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x325:
;    1262          if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x326
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x326:
;    1263         b=bb0[1];
	__GETW1MN _bb0,2
	CALL SUBOPT_0xA1
;    1264          if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x327
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x327:
;    1265          if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x328
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x328:
;    1266          if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x329
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x329:
;    1267          if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x32A
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x32A:
;    1268         data_odeslat_int[2]=a; a=0; b=0;
	MOVW R26,R28
	ADIW R26,13
	ST   X+,R20
	ST   X,R21
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
;    1269         for (i=0;i<6;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x32C:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,6
	BRLT PC+3
	JMP _0x32D
;    1270           a=0; b=data0[2*i+1];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB4
	__ADDW2MN _data0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1271            if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x32E
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x32E:
;    1272            if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x32F
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x32F:
;    1273            if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x330
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x330:
;    1274            if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x331
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x331:
;    1275           b=data0[2*i+2];
	CALL SUBOPT_0xB5
	__ADDW2MN _data0,4
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1276            if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x332
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x332:
;    1277            if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x333
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x333:
;    1278            if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x334
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x334:
;    1279            if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x335
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x335:
;    1280           data_odeslat_int[i+4]=a; a=0; b=0;            };
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,4
	CALL SUBOPT_0xB6
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
	CALL SUBOPT_0x91
	RJMP _0x32C
_0x32D:
;    1281         data_odeslat_int[0]=85;
	CALL SUBOPT_0xB7
;    1282         data_odeslat_int[1]=typ_zpravy+0+4;
	ADIW R30,4
	STD  Y+11,R30
	STD  Y+11+1,R31
;    1283         data_odeslat_int[3]=0;
	LDI  R30,0
	STD  Y+15,R30
	STD  Y+15+1,R30
;    1284         if (data_odeslat_int[2]==0) {  data_odeslat_int[3]=128;  data_odeslat_int[2]=255; }
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	SBIW R30,0
	BRNE _0x336
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	STD  Y+15,R30
	STD  Y+15+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+13,R30
	STD  Y+13+1,R31
;    1285         if (data_odeslat_int[3]==0) {  data_odeslat_int[3]=64;   }
_0x336:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	SBIW R30,0
	BRNE _0x337
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	STD  Y+15,R30
	STD  Y+15+1,R31
;    1286         krok=5;
_0x337:
	__GETWRN 18,19,5
;    1287       break;
	RJMP _0x321
;    1288       case 1:
_0x322:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x338
;    1289         generate_gf();
	CALL SUBOPT_0xB3
;    1290         gen_poly0();
;    1291         encode_rs0();
;    1292         for (i=0;i<2;i++) { 
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x33A:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,2
	BRLT PC+3
	JMP _0x33B
;    1293          a=0; b=bb0[2*i];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xA1
;    1294           if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x33C
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x33C:
;    1295           if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x33D
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x33D:
;    1296           if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x33E
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x33E:
;    1297           if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x33F
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x33F:
;    1298          b=bb0[2*i+1];
	CALL SUBOPT_0xB4
	__ADDW2MN _bb0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1299           if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x340
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x340:
;    1300           if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x341
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x341:
;    1301           if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x342
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x342:
;    1302           if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x343
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x343:
;    1303          data_odeslat_int[2+i]=a; a=0; b=0;
	CALL SUBOPT_0xB9
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
;    1304         }
	CALL SUBOPT_0x91
	RJMP _0x33A
_0x33B:
;    1305         for (i=0;i<5;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x345:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,5
	BRLT PC+3
	JMP _0x346
;    1306           a=0; b=data0[2*i+1];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB4
	__ADDW2MN _data0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1307            if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x347
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x347:
;    1308            if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x348
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x348:
;    1309            if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x349
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x349:
;    1310            if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x34A
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x34A:
;    1311           b=data0[2*i+2];
	CALL SUBOPT_0xB5
	__ADDW2MN _data0,4
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1312            if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x34B
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x34B:
;    1313            if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x34C
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x34C:
;    1314            if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x34D
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x34D:
;    1315            if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x34E
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x34E:
;    1316           data_odeslat_int[i+5]=a; a=0; b=0;            };
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,5
	CALL SUBOPT_0xB6
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
	CALL SUBOPT_0x91
	RJMP _0x345
_0x346:
;    1317         data_odeslat_int[0]=85;
	CALL SUBOPT_0xB7
;    1318         data_odeslat_int[1]=typ_zpravy+1+4;
	ADIW R30,5
	STD  Y+11,R30
	STD  Y+11+1,R31
;    1319         data_odeslat_int[4]=0;
	LDI  R30,0
	STD  Y+17,R30
	STD  Y+17+1,R30
;    1320         if (data_odeslat_int[2]==0) {  data_odeslat_int[4]=128;  data_odeslat_int[2]=255; }
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	SBIW R30,0
	BRNE _0x34F
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	STD  Y+17,R30
	STD  Y+17+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+13,R30
	STD  Y+13+1,R31
;    1321         if (data_odeslat_int[3]==0) {  data_odeslat_int[4]=32+data_odeslat_int[4];  data_odeslat_int[3]=255; }
_0x34F:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	SBIW R30,0
	BRNE _0x350
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ADIW R30,32
	STD  Y+17,R30
	STD  Y+17+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+15,R30
	STD  Y+15+1,R31
;    1322         if (data_odeslat_int[4]==0) {  data_odeslat_int[4]=64;   }
_0x350:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	SBIW R30,0
	BRNE _0x351
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	STD  Y+17,R30
	STD  Y+17+1,R31
;    1323         krok=5;
_0x351:
	__GETWRN 18,19,5
;    1324       break;
	RJMP _0x321
;    1325       case 2:
_0x338:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x352
;    1326         generate_gf();
	CALL SUBOPT_0xB3
;    1327         gen_poly0();
;    1328         encode_rs0();
;    1329         for (i=0;i<3;i++) { 
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x354:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,3
	BRLT PC+3
	JMP _0x355
;    1330          a=0; b=bb0[2*i];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xA1
;    1331           if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x356
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x356:
;    1332           if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x357
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x357:
;    1333           if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x358
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x358:
;    1334           if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x359
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x359:
;    1335          b=bb0[2*i+1];
	CALL SUBOPT_0xB4
	__ADDW2MN _bb0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1336           if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x35A
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x35A:
;    1337           if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x35B
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x35B:
;    1338           if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x35C
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x35C:
;    1339           if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x35D
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x35D:
;    1340          data_odeslat_int[2+i]=a; a=0; b=0;
	CALL SUBOPT_0xB9
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
;    1341         }
	CALL SUBOPT_0x91
	RJMP _0x354
_0x355:
;    1342         for (i=0;i<4;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x35F:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,4
	BRLT PC+3
	JMP _0x360
;    1343           a=0; b=data0[2*i+1];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB4
	__ADDW2MN _data0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1344            if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x361
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x361:
;    1345            if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x362
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x362:
;    1346            if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x363
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x363:
;    1347            if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x364
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x364:
;    1348           b=data0[2*i+2];
	CALL SUBOPT_0xB5
	__ADDW2MN _data0,4
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1349            if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x365
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x365:
;    1350            if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x366
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x366:
;    1351            if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x367
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x367:
;    1352            if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x368
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x368:
;    1353           data_odeslat_int[i+6]=a; a=0; b=0;            };
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,6
	CALL SUBOPT_0xB6
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
	CALL SUBOPT_0x91
	RJMP _0x35F
_0x360:
;    1354         data_odeslat_int[0]=85;
	CALL SUBOPT_0xB7
;    1355         data_odeslat_int[1]=typ_zpravy+2+4;
	ADIW R30,6
	STD  Y+11,R30
	STD  Y+11+1,R31
;    1356         data_odeslat_int[5]=0;
	LDI  R30,0
	STD  Y+19,R30
	STD  Y+19+1,R30
;    1357         if (data_odeslat_int[2]==0) {  data_odeslat_int[5]=128;  data_odeslat_int[2]=255; }
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	SBIW R30,0
	BRNE _0x369
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	STD  Y+19,R30
	STD  Y+19+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+13,R30
	STD  Y+13+1,R31
;    1358         if (data_odeslat_int[3]==0) {  data_odeslat_int[5]=32+data_odeslat_int[5];  data_odeslat_int[3]=255; }
_0x369:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	SBIW R30,0
	BRNE _0x36A
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ADIW R30,32
	STD  Y+19,R30
	STD  Y+19+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+15,R30
	STD  Y+15+1,R31
;    1359         if (data_odeslat_int[4]==0) {  data_odeslat_int[5]=8+data_odeslat_int[5];  data_odeslat_int[4]=255; }
_0x36A:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	SBIW R30,0
	BRNE _0x36B
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ADIW R30,8
	STD  Y+19,R30
	STD  Y+19+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+17,R30
	STD  Y+17+1,R31
;    1360         if (data_odeslat_int[5]==0) {  data_odeslat_int[5]=64;   }
_0x36B:
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	SBIW R30,0
	BRNE _0x36C
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	STD  Y+19,R30
	STD  Y+19+1,R31
;    1361         krok=5;
_0x36C:
	__GETWRN 18,19,5
;    1362       break;
	RJMP _0x321
;    1363       case 3:
_0x352:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x321
;    1364         generate_gf();
	CALL SUBOPT_0xB3
;    1365         gen_poly0();
;    1366         encode_rs0();
;    1367         for (i=0;i<4;i++) { 
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x36F:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,4
	BRLT PC+3
	JMP _0x370
;    1368          a=0; b=bb0[2*i];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xA1
;    1369           if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x371
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x371:
;    1370           if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x372
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x372:
;    1371           if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x373
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x373:
;    1372           if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x374
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x374:
;    1373          b=bb0[2*i+1];
	CALL SUBOPT_0xB4
	__ADDW2MN _bb0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1374           if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x375
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x375:
;    1375           if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x376
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x376:
;    1376           if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x377
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x377:
;    1377           if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x378
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x378:
;    1378          data_odeslat_int[2+i]=a; a=0; b=0;
	CALL SUBOPT_0xB9
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
;    1379         }
	CALL SUBOPT_0x91
	RJMP _0x36F
_0x370:
;    1380         for (i=0;i<3;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x37A:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,3
	BRLT PC+3
	JMP _0x37B
;    1381           a=0; b=data0[2*i+1];
	__GETWRN 20,21,0
	CALL SUBOPT_0xB4
	__ADDW2MN _data0,2
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1382            if ( b>=8 ) { a=128;  b=b-8; };
	BRLT _0x37C
	__GETWRN 20,21,128
	CALL SUBOPT_0xA2
_0x37C:
;    1383            if ( b>=4 ) { a=a+64; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x37D
	__ADDWRN 20,21,64
	CALL SUBOPT_0xA3
_0x37D:
;    1384            if ( b>=2 ) { a=a+32; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x37E
	__ADDWRN 20,21,32
	CALL SUBOPT_0xA4
_0x37E:
;    1385            if ( b>=1 ) { a=a+16; b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x37F
	__ADDWRN 20,21,16
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x37F:
;    1386           b=data0[2*i+2];
	CALL SUBOPT_0xB5
	__ADDW2MN _data0,4
	CALL __GETW1P
	CALL SUBOPT_0xA1
;    1387            if ( b>=8 ) { a=a+8; b=b-8; };
	BRLT _0x380
	__ADDWRN 20,21,8
	CALL SUBOPT_0xA2
_0x380:
;    1388            if ( b>=4 ) { a=a+4; b=b-4; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,4
	BRLT _0x381
	__ADDWRN 20,21,4
	CALL SUBOPT_0xA3
_0x381:
;    1389            if ( b>=2 ) { a=a+2; b=b-2; };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,2
	BRLT _0x382
	__ADDWRN 20,21,2
	CALL SUBOPT_0xA4
_0x382:
;    1390            if ( b>=1 ) { a++;   b=0;   };
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,1
	BRLT _0x383
	__ADDWRN 20,21,1
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
_0x383:
;    1391           data_odeslat_int[i+7]=a; a=0; b=0;            };
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,7
	CALL SUBOPT_0xB6
	__GETWRN 20,21,0
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
	CALL SUBOPT_0x91
	RJMP _0x37A
_0x37B:
;    1392         data_odeslat_int[0]=85;
	CALL SUBOPT_0xB7
;    1393         data_odeslat_int[1]=typ_zpravy+3+4;
	ADIW R30,7
	STD  Y+11,R30
	STD  Y+11+1,R31
;    1394         data_odeslat_int[6]=0;
	LDI  R30,0
	STD  Y+21,R30
	STD  Y+21+1,R30
;    1395         if (data_odeslat_int[2]==0) {  data_odeslat_int[6]=128;  data_odeslat_int[2]=255; }
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	SBIW R30,0
	BRNE _0x384
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	STD  Y+21,R30
	STD  Y+21+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+13,R30
	STD  Y+13+1,R31
;    1396         if (data_odeslat_int[3]==0) {  data_odeslat_int[6]=32+data_odeslat_int[6];  data_odeslat_int[3]=255; }
_0x384:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	SBIW R30,0
	BRNE _0x385
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ADIW R30,32
	STD  Y+21,R30
	STD  Y+21+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+15,R30
	STD  Y+15+1,R31
;    1397         if (data_odeslat_int[4]==0) {  data_odeslat_int[6]=8+data_odeslat_int[6];  data_odeslat_int[4]=255; }
_0x385:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	SBIW R30,0
	BRNE _0x386
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ADIW R30,8
	STD  Y+21,R30
	STD  Y+21+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+17,R30
	STD  Y+17+1,R31
;    1398         if (data_odeslat_int[5]==0) {  data_odeslat_int[6]=2+data_odeslat_int[6];  data_odeslat_int[5]=255; }
_0x386:
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	SBIW R30,0
	BRNE _0x387
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ADIW R30,2
	STD  Y+21,R30
	STD  Y+21+1,R31
	LDI  R30,LOW(255)
	LDI  R31,HIGH(255)
	STD  Y+19,R30
	STD  Y+19+1,R31
;    1399         if (data_odeslat_int[6]==0) {  data_odeslat_int[6]=64;   }
_0x387:
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	SBIW R30,0
	BRNE _0x388
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	STD  Y+21,R30
	STD  Y+21+1,R31
;    1400         krok=5;
_0x388:
	__GETWRN 18,19,5
;    1401       break;
;    1402     };
_0x321:
;    1403     //PORTB.2=0;
;    1404   };
	RJMP _0x31C
_0x31E:
;    1405   while ( (krok==5)&&(UCSRA&0x20) ) {
_0x389:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x38C
	SBIC 0xB,5
	RJMP _0x38D
_0x38C:
	RJMP _0x38B
_0x38D:
;    1406     for (i=0;i<10;i++) {
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x38F:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,10
	BRGE _0x390
;    1407       //if (data_odeslat_int[i]==0) {data_odeslat_int[i]=235;};
;    1408       putchar(data_odeslat_int[i]);
	CALL SUBOPT_0xBA
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	CALL _putchar
;    1409       delay_us(200);
	__DELAY_USB 246
;    1410     };
	CALL SUBOPT_0x91
	RJMP _0x38F
_0x390:
;    1411     krok=0;
	__GETWRN 18,19,0
;    1412     for (i=0;i<8;i++) { data_odeslat_int[i]=0; };
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x392:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,8
	BRGE _0x393
	CALL SUBOPT_0xBA
	CALL SUBOPT_0x14
	CALL SUBOPT_0x91
	RJMP _0x392
_0x393:
;    1413     for (i=0;i<16;i++) { recd[i]=0; };
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x395:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,16
	BRGE _0x396
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
	CALL SUBOPT_0x91
	RJMP _0x395
_0x396:
;    1414     for (i=0;i<12;i++) { data0[i]=0; };
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x398:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,12
	BRGE _0x399
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDI  R26,LOW(_data0)
	LDI  R27,HIGH(_data0)
	LSL  R30
	ROL  R31
	CALL SUBOPT_0x14
	CALL SUBOPT_0x91
	RJMP _0x398
_0x399:
;    1415     for (i=0;i<2;i++) { bb0[i]=0; };
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
_0x39B:
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	SBIW R26,2
	BRGE _0x39C
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	CALL SUBOPT_0xE
	CALL SUBOPT_0x91
	RJMP _0x39B
_0x39C:
;    1416     //delay_ms(1000);
;    1417     //PORTB=0xFF;
;    1418   };
	RJMP _0x389
_0x38B:
;    1419 }; // konec hlavniho while
	JMP  _0x22C
;    1420 } // konec main
_0x39D:
	RJMP _0x39D
;    1421  
;    1422  
;    1423  

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x0:
	MOVW R30,R16
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ST   X+,R16
	ST   X,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 503 TIMES
SUBOPT_0x2:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4:
	MOVW R30,R16
	SBIW R30,1
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	MOVW R30,R16
	LDI  R26,LOW(_gg)
	LDI  R27,HIGH(_gg)
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x7:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x8:
	MOVW R30,R18
	LDI  R26,LOW(_gg)
	LDI  R27,HIGH(_gg)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	MOVW R30,R18
	LDI  R26,LOW(_gg)
	LDI  R27,HIGH(_gg)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	MOVW R30,R18
	SBIW R30,1
	LDI  R26,LOW(_gg)
	LDI  R27,HIGH(_gg)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X+
	LD   R23,X
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	ADD  R30,R16
	ADC  R31,R17
	MOVW R26,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL __MODW21
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES
SUBOPT_0xD:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LDI  R26,LOW(_bb0)
	LDI  R27,HIGH(_bb0)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xF:
	MOVW R30,R18
	LDI  R26,LOW(_bb0)
	LDI  R27,HIGH(_bb0)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	MOVW R30,R18
	SBIW R30,1
	LDI  R26,LOW(_bb0)
	LDI  R27,HIGH(_bb0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x11:
	MOVW R26,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x12:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL __MODW21
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x13:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,52
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 30 TIMES
SUBOPT_0x14:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	MOVW R30,R18
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	MOVW R30,R18
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X+
	LD   R23,X
	MOVW R30,R18
	MOVW R26,R16
	CALL __MULW12
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x17:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,52
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	SUB  R30,R11
	SBC  R31,R12
	CP   R16,R30
	CPC  R17,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x19:
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1A:
	MOVW R26,R30
	MOVW R30,R16
	LSL  R30
	ROL  R31
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x1D:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1E:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1F:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x20:
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	MOVW R30,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x21:
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	__GETW1SX 98
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x23:
	CALL __GETW1P
	SBIW R30,1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES
SUBOPT_0x24:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X+
	LD   R1,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x25:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X+
	LD   R23,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x26:
	__GETW1SX 98
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	ADD  R30,R20
	ADC  R31,R21
	__GETW2SX 98
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x28:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(66))
	SBCI R27,HIGH(-(66))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x29:
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x2A:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2B:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	MOVW R30,R20
	ADD  R30,R16
	ADC  R31,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2C:
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 61 TIMES
SUBOPT_0x2D:
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2E:
	MOVW R26,R30
	MOVW R30,R20
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	SUB  R30,R11
	SBC  R31,R12
	CP   R20,R30
	CPC  R21,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,52
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x31:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES
SUBOPT_0x32:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	MOVW R30,R20
	ADIW R30,1
	SUB  R30,R16
	SBC  R31,R17
	MOVW R26,R28
	ADIW R26,52
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	MOVW R30,R20
	ADIW R30,1
	RJMP SUBOPT_0x21

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x35:
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,6
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x36:
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,6
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x37:
	MOVW R26,R22
	ST   X+,R30
	ST   X,R31
	RJMP SUBOPT_0x35

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x38:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ST   X+,R16
	ST   X,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x39:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,40
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3A:
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,52
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	SUB  R30,R18
	SBC  R31,R19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x3C:
	MOVW R30,R16
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x3D:
	MOVW R30,R16
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	LSL  R30
	ROL  R31
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x3E:
	MOVW R30,R16
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	RJMP SUBOPT_0x32

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x3F:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,44
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x40:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,46
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x41:
	MOVW R26,R18
	CALL __MULW12
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x42:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	EOR  R30,R26
	EOR  R31,R27
	LDI  R26,LOW(_index_of)
	LDI  R27,HIGH(_index_of)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x43:
	MOVW R22,R30
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	MOVW R24,R30
	LD   R0,Z
	LDD  R1,Z+1
	MOVW R30,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x44:
	EOR  R30,R0
	EOR  R31,R1
	MOVW R26,R24
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x45:
	__GETW1R 7,8
	SUB  R30,R11
	SBC  R31,R12
	CP   R30,R16
	CPC  R31,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x46:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,60
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x47:
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 7,8
	CALL __MODW21
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x48:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,60
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x49:
	__GETW1R 7,8
	SUB  R30,R11
	SBC  R31,R12
	CP   R16,R30
	CPC  R17,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4A:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4B:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(94))
	SBCI R27,HIGH(-(94))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0x4C:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4D:
	MOVW R30,R20
	ADIW R30,1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x4E:
	MOVW R30,R20
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4F:
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x50:
	__GETW1SX 154
	MOVW R26,R28
	SUBI R26,LOW(-(94))
	SBCI R27,HIGH(-(94))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x51:
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(94))
	SBCI R27,HIGH(-(94))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x52:
	__GETW1SX 154
	MOVW R26,R28
	SUBI R26,LOW(-(82))
	SBCI R27,HIGH(-(82))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x53:
	ADD  R30,R20
	ADC  R31,R21
	__GETW2SX 154
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x54:
	__GETW1R 7,8
	SUB  R30,R11
	SBC  R31,R12
	CP   R20,R30
	CPC  R21,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x55:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,60
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x56:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(94))
	SBCI R27,HIGH(-(94))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x57:
	MOVW R30,R20
	ADIW R30,1
	SUB  R30,R16
	SBC  R31,R17
	MOVW R26,R28
	ADIW R26,60
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x58:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,6
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x59:
	ADD  R30,R18
	ADC  R31,R19
	MOVW R26,R30
	__GETW1R 7,8
	CALL __MODW21
	RJMP SUBOPT_0x37

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5A:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 7,8
	SUB  R30,R16
	SBC  R31,R17
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x5B:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,42
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5C:
	MOVW R30,R18
	MOVW R26,R28
	ADIW R26,60
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5D:
	MOVW R30,R20
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	SUB  R30,R18
	SBC  R31,R19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x5E:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,48
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5F:
	SUB  R30,R26
	SBC  R31,R27
	ADD  R30,R7
	ADC  R31,R8
	MOVW R26,R30
	__GETW1R 7,8
	CALL __MODW21
	LDI  R26,LOW(_alpha_to)
	LDI  R27,HIGH(_alpha_to)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x60:
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x61:
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES
SUBOPT_0x62:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(114))
	SBCI R27,HIGH(-(114))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x63:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0x64:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x65:
	MOVW R30,R20
	ADIW R30,1
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	CALL __MULW12U
	MOVW R26,R28
	SUBI R26,LOW(-(130))
	SBCI R27,HIGH(-(130))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x66:
	MOVW R30,R20
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	CALL __MULW12U
	MOVW R26,R28
	SUBI R26,LOW(-(130))
	SBCI R27,HIGH(-(130))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x67:
	__GETW1SX 226
	MOVW R26,R28
	SUBI R26,LOW(-(114))
	SBCI R27,HIGH(-(114))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x68:
	__GETW1SX 226
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x69:
	ADD  R30,R20
	ADC  R31,R21
	__GETW2SX 226
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x6A:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(98))
	SBCI R27,HIGH(-(98))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6B:
	__GETW1SX 226
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	CALL __MULW12U
	MOVW R26,R28
	SUBI R26,LOW(-(130))
	SBCI R27,HIGH(-(130))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x6C:
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	CALL __MULW12U
	MOVW R26,R28
	SUBI R26,LOW(-(130))
	SBCI R27,HIGH(-(130))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6D:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x6E:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(114))
	SBCI R27,HIGH(-(114))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6F:
	MOVW R30,R20
	ADIW R30,1
	SUB  R30,R16
	SBC  R31,R17
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x70:
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x71:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,44
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x72:
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(68))
	SBCI R27,HIGH(-(68))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x73:
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	SUB  R30,R18
	SBC  R31,R19
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x74:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,58
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x75:
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x76:
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x77:
	MOVW R30,R20
	MOVW R26,R28
	SUBI R26,LOW(-(134))
	SBCI R27,HIGH(-(134))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x78:
	MOVW R30,R20
	ADIW R30,1
	CALL __LSLW4
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x79:
	MOVW R30,R20
	CALL __LSLW4
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x7A:
	CALL __LSLW4
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	ADD  R26,R30
	ADC  R27,R31
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7B:
	__GETW1SX 314
	MOVW R26,R28
	SUBI R26,LOW(-(134))
	SBCI R27,HIGH(-(134))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x7C:
	__GETW1SX 314
	MOVW R26,R28
	SUBI R26,LOW(-(114))
	SBCI R27,HIGH(-(114))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7D:
	ADD  R30,R20
	ADC  R31,R21
	__GETW2SX 314
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7E:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x7F:
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	SUBI R26,LOW(-(134))
	SBCI R27,HIGH(-(134))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x80:
	MOVW R30,R20
	ADIW R30,1
	SUB  R30,R16
	SBC  R31,R17
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x81:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,46
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x82:
	MOVW R30,R18
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x83:
	MOVW R30,R20
	CALL __LSLW4
	MOVW R26,R28
	SUBI R26,LOW(-(154))
	SBCI R27,HIGH(-(154))
	RJMP SUBOPT_0x73

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x84:
	MOVW R30,R16
	MOVW R26,R28
	ADIW R26,56
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x85:
	MOVW R30,R16
	MOVW R26,R28
	SUBI R26,LOW(-(64))
	SBCI R27,HIGH(-(64))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x86:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,Y
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,1
	STD  Y+5,R30
	STD  Y+5+1,R31
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x87:
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
	LDI  R30,LOW(0)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x88:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 13,14
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	__PUTW1R 11,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x89:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	MOVW R26,R28
	SUBI R26,LOW(-(289))
	SBCI R27,HIGH(-(289))
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x8A:
	STD  Y+7,R30
	STD  Y+7+1,R31
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x8B:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SUBI R30,LOW(128)
	SBCI R31,HIGH(128)
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x8C:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SUBI R30,LOW(64)
	SBCI R31,HIGH(64)
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x8D:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SBIW R30,32
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x8E:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SBIW R30,16
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x8F:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LSL  R30
	ROL  R31
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ST   X+,R20
	ST   X,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x90:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LSL  R30
	ROL  R31
	ADIW R30,1
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	STD  Z+0,R26
	STD  Z+1,R27
	LDI  R30,0
	STD  Y+7,R30
	STD  Y+7+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 45 TIMES
SUBOPT_0x91:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,1
	STD  Y+5,R30
	STD  Y+5+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x92:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SBIW R30,1
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0x93:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x94:
	CALL _generate_gf
	CALL _gen_poly0
	LDI  R30,0
	STD  Y+5,R30
	STD  Y+5+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x95:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDI  R26,LOW(_recd)
	LDI  R27,HIGH(_recd)
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x96:
	CALL _decode_rs0
	LDI  R30,LOW(1)
	CP   R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x97:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LDI  R26,LOW(_data0)
	LDI  R27,HIGH(_data0)
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x98:
	CALL __GETW1P
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x99:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	__PUTW1R 13,14
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	__PUTW1R 11,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9A:
	CLR  R4
	CALL _decode_rs1
	LDI  R30,LOW(1)
	CP   R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9B:
	MOVW R30,R28
	SUBI R30,LOW(-(289))
	SBCI R31,HIGH(-(289))
	ADIW R30,6
	MOVW R26,R30
	__GETW1SX 295
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9C:
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	__PUTW1R 13,14
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	__PUTW1R 11,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9D:
	CLR  R4
	CALL _decode_rs2
	LDI  R30,LOW(1)
	CP   R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x9E:
	MOVW R30,R28
	SUBI R30,LOW(-(289))
	SBCI R31,HIGH(-(289))
	ADIW R30,8
	MOVW R26,R30
	__GETW1SX 297
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9F:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	__PUTW1R 13,14
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	__PUTW1R 11,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA0:
	CLR  R4
	CALL _decode_rs3
	LDI  R30,LOW(1)
	CP   R30,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES
SUBOPT_0xA1:
	STD  Y+7,R30
	STD  Y+7+1,R31
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	SBIW R26,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES
SUBOPT_0xA2:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SBIW R30,8
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES
SUBOPT_0xA3:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SBIW R30,4
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES
SUBOPT_0xA4:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	SBIW R30,2
	STD  Y+7,R30
	STD  Y+7+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xA5:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA6:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ADIW R30,1
	STD  Y+3,R30
	STD  Y+3+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA7:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,29
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA8:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,0
	MOVW R26,R28
	ADIW R26,29
	LSL  R30
	ROL  R31
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA9:
	CALL __MULW12
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	ADD  R30,R26
	ADC  R31,R27
	LDI  R26,LOW(_data0_prokladane)
	LDI  R27,HIGH(_data0_prokladane)
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xAA:
	CALL __MULW12
	MOVW R26,R30
	LSL  R26
	ROL  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xAB:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,2
	MOVW R26,R28
	ADIW R26,29
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xAC:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,2
	MOVW R26,R28
	ADIW R26,29
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xAD:
	SUBI R30,LOW(128)
	SBCI R31,HIGH(128)
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xAE:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,3
	MOVW R26,R28
	ADIW R26,29
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xAF:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,3
	MOVW R26,R28
	ADIW R26,29
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB0:
	SBIW R30,32
	MOVW R26,R0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xB1:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,29
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xB2:
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	CALL __LSLW3
	ADIW R30,4
	MOVW R26,R28
	ADIW R26,29
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xB3:
	CALL _generate_gf
	CALL _gen_poly0
	JMP  _encode_rs0

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0xB4:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LSL  R30
	ROL  R31
	MOVW R26,R30
	LSL  R26
	ROL  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xB5:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LSL  R30
	ROL  R31
	MOVW R26,R30
	LSL  R26
	ROL  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0xB6:
	MOVW R26,R28
	ADIW R26,9
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	ST   X+,R20
	ST   X,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xB7:
	LDI  R30,LOW(85)
	LDI  R31,HIGH(85)
	STD  Y+9,R30
	STD  Y+9+1,R31
	__GETW1R 5,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xB8:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LSL  R30
	ROL  R31
	LDI  R26,LOW(_bb0)
	LDI  R27,HIGH(_bb0)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xB9:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,2
	RJMP SUBOPT_0xB6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xBA:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	MOVW R26,R28
	ADIW R26,9
	LSL  R30
	ROL  R31
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__EQW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BREQ __EQW12T
	CLR  R30
__EQW12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
